/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ ou Rg[ ]
 */

#if XM7_VER == 1 && defined(BUBBLE)

#include <string.h>
#include <stdlib.h>
#include "xm7.h"
#include "device.h"
#include "bubble.h"
#include "fdc.h"
#include "mouse.h"
#include "opn.h"
#include "event.h"

/*
 *	O[o [N
 */

/* WX^ */
BYTE bmc_datareg[2];					/* f[^WX^ */
BYTE bmc_command[2];					/* R}hWX^ */
BYTE bmc_status[2];						/* Xe[^XWX^ */
BYTE bmc_errorreg[2];					/* G[Xe[^XWX^ */
WORD bmc_pagereg[2];					/* y[WWX^ */
WORD bmc_countreg[2];					/* y[WJEgWX^ */

/* O[N */
WORD bmc_totalcnt[2];					/* g[^JE^ */
WORD bmc_nowcnt[2];						/* JgJE^ */
BYTE bmc_unit[2];						/* jbg */
BYTE bmc_ready[2][BMC_UNITS_128];		/* fB */
BOOL bmc_teject[2][BMC_UNITS_128];		/* ꎞCWFNg */
BOOL bmc_writep[2][BMC_UNITS_128];		/* ݋֎~ */

char bmc_fname[2][BMC_UNITS_128][256+1];/* t@C */
char bmc_name[2][BMC_UNITS_128][BMC_MEDIAS][17];
BOOL bmc_fwritep[2][BMC_UNITS_128];		/* CgveNg */
BYTE bmc_header[2][BMC_UNITS_128][0x20];/* B77t@Cwb_ */
BYTE bmc_medias[2][BMC_UNITS_128];		/* fBA */
BYTE bmc_media[2][BMC_UNITS_128];		/* fBAZNg */
BYTE bmc_access[2][BMC_UNITS_128];		/* ANZXLED */

BOOL bmc_enable[2];						/* LEtO */
BOOL bmc_use[2];						/* gptO */
BOOL bmc_secret_flag;					/* BtO */

/*
 *	X^eBbN [N
 */
static BYTE bmc_buffer0[BMC_PSIZE_32];	/* 32bytef[^obt@ */
static BYTE bmc_buffer1[BMC_PSIZE_128];	/* 128bytef[^obt@ */
static BYTE * const bmc_buffer[2] = {&bmc_buffer0[0], &bmc_buffer1[0]};
static BYTE *bmc_dataptr[2];			/* f[^|C^ */
static DWORD bmc_offset[2];				/* ItZbg */
static DWORD bmc_foffset[2][BMC_UNITS_128][BMC_MEDIAS];
static DWORD bmc_fsize[2][BMC_UNITS_128];
static BOOL bmc_wait;					/* EFCg[hstO */

/*
 *	Œle[u
 */
static const WORD bmc_page_size[2] = {	BMC_PSIZE_32,
										BMC_PSIZE_128};
static const WORD bmc_max_addr[2] = {	BMC_MAXADDR_32,
										BMC_MAXADDR_128};

static void FASTCALL bmc_make_stat(int type);	/* Xe[^X쐬 */
static BOOL FASTCALL bmc32_lost_event(void);	/* Xgf[^ 32KB */
static BOOL FASTCALL bmc128_lost_event(void);	/* Xgf[^ 128KB */
static void FASTCALL bmc_read_data(int type);	/* y[Wǂݍ݊Jn */
static void FASTCALL bmc_write_data(int type);	/* y[Wݍ݊Jn */

/*
 *	ID
 */
#define	ID	MAKEID('B', 'M', 'C', ' ')
//#define BMC_LOG

/*
 *	ou Rg[
 *	
 */
BOOL FASTCALL bmc_init(void)
{
	/* t@C֌WZbg */
	memset(bmc_totalcnt, 0, sizeof(bmc_totalcnt));
	memset(bmc_nowcnt, 0, sizeof(bmc_nowcnt));

	memset(bmc_ready, BMC_TYPE_NOTREADY, sizeof(bmc_ready));
	memset(bmc_teject, FALSE, sizeof(bmc_teject));
	memset(bmc_writep, FALSE, sizeof(bmc_writep));
	memset(bmc_fname, 0, sizeof(bmc_fname));
	memset(bmc_fwritep, FALSE, sizeof(bmc_fwritep));
	memset(bmc_medias, 0, sizeof(bmc_medias));

	/* t@CItZbgSăNA */
	memset(bmc_foffset, 0, sizeof(bmc_foffset));

	/* ftHg32KBE128KB */
	bmc_enable[BMC_32] = FALSE;
	bmc_enable[BMC_128] = FALSE;

	/* EFCg}[htO */
	bmc_wait = FALSE;

	return TRUE;
}

/*
 *	ou Rg[
 *	N[Abv
 */
void FASTCALL bmc_cleanup(void)
{
	/* t@C֌WZbg */
	memset(bmc_ready, 0, sizeof(bmc_ready));
}

/*
 *	ou Rg[
 *	Zbg
 */
void FASTCALL bmc_reset(void)
{
	LOG0(Normal, "Zbg");

	/* WX^Zbg */
	memset(bmc_datareg, 0, sizeof(bmc_datareg));
	memset(bmc_command, 0, sizeof(bmc_command));
	memset(bmc_status, BMC_ST_NONE, sizeof(bmc_status));
	memset(bmc_errorreg, 0, sizeof(bmc_errorreg));
	memset(bmc_pagereg, 0, sizeof(bmc_pagereg));
	memset(bmc_countreg, 0, sizeof(bmc_countreg));

	memset(bmc_access, 0, sizeof(bmc_access));
	memset(bmc_dataptr, 0, sizeof(bmc_dataptr));
	memset(bmc_offset, 0, sizeof(bmc_offset));
	memset(bmc_use, FALSE, sizeof(bmc_use));

	bmc_unit[BMC_32] = BMC_UNITS_32 - 1;
	bmc_unit[BMC_128] = BMC_UNITS_128 - 1;

	/* Xe[^X쐬 */
	bmc_make_stat(BMC_32);
	bmc_make_stat(BMC_128);
	bubble_notify(BMC_32);
	bubble_notify(BMC_128);
}

/*-[ t@CǗ ]---------------------------------------------------------*/

/*
 *	y[WݏI
 */
static BOOL FASTCALL bmc_write_page(int type)
{
	DWORD offset;
	int handle;

	/* assert */
	ASSERT(bmc_ready[type][bmc_unit[type]] != BMC_TYPE_NOTREADY);
	ASSERT(bmc_dataptr[type]);
	ASSERT(bmc_totalcnt[type] > 0);

	/* ItZbgZo */
	offset = (DWORD)((bmc_pagereg[type] & bmc_max_addr[type]) * bmc_page_size[type]);
	if (bmc_ready[type][bmc_unit[type]] == BMC_TYPE_B77) {
		if (bmc_fsize[type][bmc_unit[type]] < offset + bmc_page_size[type] + 0x0020) {
			return FALSE;
		}
		offset += *(DWORD *)(&bmc_header[type][bmc_unit[type]][0x0014]);
	}

	/*  */
	handle = file_open(bmc_fname[type][bmc_unit[type]], OPEN_RW);
	if (handle == -1) {
		return FALSE;
	}
	if (!file_seek(handle, offset)) {
		file_close(handle);
		return FALSE;
	}
	if (!file_write(handle, bmc_dataptr[type], bmc_totalcnt[type])) {
		file_close(handle);
		return FALSE;
	}
	file_close(handle);

	return TRUE;
}

/*
 *	y[Wǂݍ
 */
static BOOL FASTCALL bmc_readbuf(int type)
{
	int handle;
	DWORD offset;
#ifdef BMC_LOG
	LOG2(Normal, LGFMT "type:%d",
				 LGARG, type);
#endif

	/* y[WAhX`FbN */
	if (type == BMC_32) {
		if (bmc_unit[type] >= BMC_UNITS_32) {
			LOG1(Warning, "unit:%d\n", bmc_unit[type]);
			memset(bmc_buffer[type], 0, bmc_page_size[type]);
			return FALSE;
		}
	}
	else {
		if (bmc_unit[type] >= BMC_UNITS_128) {
			LOG1(Warning, "unit:%d\n", bmc_unit[type]);
			memset(bmc_buffer[type], 0, bmc_page_size[type]);
			return FALSE;
		}
	}

	/* fB`FbN */
	if (bmc_ready[type][bmc_unit[type]] == BMC_TYPE_NOTREADY) {
#ifdef BMC_LOG
		LOG1(Warning, "bmc_ready:%d\n", bmc_ready[type][bmc_unit[type]]);
#endif
		return FALSE;
	}

	/* ItZbgZo */
	offset = (DWORD)(bmc_pagereg[type] & bmc_max_addr[type]);
	offset *= bmc_page_size[type];
	if (bmc_ready[type][bmc_unit[type]] == BMC_TYPE_B77) {
		if (bmc_fsize[type][bmc_unit[type]] < offset + bmc_page_size[type] + 0x0020) {
			return FALSE;
		}
		offset += *(DWORD *)(&bmc_header[type][bmc_unit[type]][0x0014]);
	}
	bmc_offset[type] = offset;

	/* ǂݍ */
	memset(bmc_buffer[type], 0, bmc_page_size[type]);
	handle = file_open(bmc_fname[type][bmc_unit[type]], OPEN_R);
	if (handle == -1) {
		return FALSE;
	}
	if (!file_seek(handle, offset)) {
		file_close(handle);
		return FALSE;
	}
	file_read(handle, bmc_buffer[type], bmc_page_size[type]);
	file_close(handle);
	return TRUE;
}

/*
 *	B77t@C wb_ǂݍ
 */
static BOOL FASTCALL bmc_readhead(int type, int unit, int index)
{
	int i;
	DWORD offset;
	DWORD temp;
	int handle;
#ifdef BMC_LOG
	LOG5(Normal, LGFMT "type:%d unit:%d index:%d bmc_ready:%d\n",
				 LGARG, type, unit, index, bmc_ready[type][unit]);
#endif

	/* assert */
	ASSERT((type == BMC_32) || (type == BMC_128));
	ASSERT((unit >= 0) && (unit < BMC_UNITS_128));
	ASSERT((index >= 0) && (index < BMC_MEDIAS));
	ASSERT(bmc_ready[type][unit] == BMC_TYPE_B77);

	/* ItZbg */
	offset = bmc_foffset[type][unit][index];
#ifdef BMC_LOG
	LOG2(Normal, LGFMT "offset:%d\n",
				 LGARG, offset);
#endif

	/* V[NAǂݍ */
	handle = file_open(bmc_fname[type][unit], OPEN_R);
	if (handle == -1) {
		return FALSE;
	}
	if (!file_seek(handle, offset)) {
		file_close(handle);
		return FALSE;
	}
	if (!file_read(handle, bmc_header[type][unit], 0x20)) {
		file_close(handle);
		return FALSE;
	}
	file_close(handle);

	/* JZbgTCY */
	temp = 0;
	temp |= bmc_header[type][unit][0x001c + 3];
	temp *= 256;
	temp |= bmc_header[type][unit][0x001c + 2];
	temp *= 256;
	temp |= bmc_header[type][unit][0x001c + 1];
	temp *= 256;
	temp |= bmc_header[type][unit][0x001c + 0];
#ifdef BMC_LOG
	LOG2(Normal, LGFMT "temp:%d\n",
				 LGARG, temp);
#endif
	bmc_fsize[type][unit] = temp;

#ifdef BMC_LOG
	LOG2(Normal, LGFMT "0x001b:%d\n",
				 LGARG, bmc_header[type][unit][0x001b]);
#endif
	/* ^Cv`FbN */
	if (type == BMC_32) {
		if (bmc_header[type][unit][0x001b] != 0x80) {
			/* 32KBłȂ */
			return FALSE;
		}
#if 0
		if (temp != 32800) {
			/* 32KBłȂ */
			return FALSE;
		}
#endif
	}
	if (type == BMC_128) {
		if (bmc_header[type][unit][0x001b] != 0x90) {
			/* 128KBłȂ */
			return FALSE;
		}
#if 0
		if (temp != 131104) {
			/* 128KBłȂ */
			return FALSE;
		}
#endif
	}

	/* CgveNgݒ */
	if (bmc_fwritep[type][unit]) {
		bmc_writep[type][unit] = TRUE;
	}
	else {
		if (bmc_header[type][unit][0x001a] & 0x10) {
			bmc_writep[type][unit] = TRUE;
		}
		else {
			bmc_writep[type][unit] = FALSE;
		}
	}

	/* ItZbg */
	*(DWORD *)(&bmc_header[type][unit][0x0014]) = offset + 0x0020;

	return TRUE;
}

/*
 *	݂̃fBÃCgveNg؂ւ
 */
BOOL FASTCALL bmc_setwritep(int type, int unit, BOOL writep)
{
	/* assert */
	ASSERT((type == BMC_32) || (type == BMC_128));
	ASSERT((unit >= 0) && (unit < BMC_UNITS_128));
	ASSERT((writep == TRUE) || (writep == FALSE));

	/* fBłȂ΂ȂȂ */
	if (bmc_ready[type][unit] == BMC_TYPE_NOTREADY) {
		return FALSE;
	}

	/* t@CݕsȂ_ */
	if (bmc_fwritep[type][unit]) {
		return FALSE;
	}

	/* ǂݍ݁AݒA */
	if (bmc_ready[type][unit] == BMC_TYPE_B77) {
		BYTE header[0x2b0];
		DWORD offset;
		int handle;

		offset = bmc_foffset[type][unit][bmc_media[type][unit]];
		handle = file_open(bmc_fname[type][unit], OPEN_RW);
		if (handle == -1) {
			return FALSE;
		}
		if (!file_seek(handle, offset)) {
			file_close(handle);
			return FALSE;
		}
		if (!file_read(handle, header, 0x20)) {
			file_close(handle);
			return FALSE;
		}
		if (writep) {
			header[0x001a] |= 0x10;
		}
		else {
			header[0x001a] &= ~0x10;
		}
		if (!file_seek(handle, offset)) {
			file_close(handle);
			return FALSE;
		}
		if (!file_write(handle, header, 0x20)) {
			file_close(handle);
			return FALSE;
		}

		file_close(handle);
	}

	/*  */
	bmc_writep[type][unit] = writep;
	return TRUE;
}

/*
 *	fBAԍݒ
 */
BOOL FASTCALL bmc_setmedia(int type, int unit, int index)
{
#ifdef BMC_LOG
	LOG4(Normal, LGFMT "type:%d unit:%d index:%d",
				 LGARG, type, unit, index);
	LOG2(Normal, LGFMT "bmc_ready[type][unit]:%d",
				 LGARG, bmc_ready[type][unit]);
#endif
	/* assert */
	ASSERT((type == BMC_32) || (type == BMC_128));
	ASSERT((unit >= 0) && (unit < BMC_UNITS_128));
	ASSERT((index >= 0) && (index < BMC_MEDIAS));

	/* fBԂ */
	if (bmc_ready[type][unit] == BMC_TYPE_NOTREADY) {
		return FALSE;
	}

	/* 32KBt@C̏ꍇAindex = 0 */
	if ((bmc_ready[type][unit] == BMC_TYPE_32) &&
		((index != 0) || (type != BMC_32))) {
		return FALSE;
	}
	/* 128KBt@C̏ꍇAindex = 0 */
	if ((bmc_ready[type][unit] == BMC_TYPE_128) &&
		((index != 0) || (type != BMC_128))) {
		return FALSE;
	}

	/* index > 0 ȂAbmc_foffset𒲂ׂ>0Kv */
	if (index > 0) {
		if (bmc_foffset[type][unit][index] == 0) {
			return FALSE;
		}
	}

	/* B77t@C̏ꍇAwb_ǂݍ */
	if (bmc_ready[type][unit] == BMC_TYPE_B77) {
		/* CgveNg͓Őݒ */
		if (!bmc_readhead(type, unit, index)) {
			return FALSE;
		}
	}
	else {
		/* 32KB/128KBt@CȂAt@Cɏ] */
		bmc_writep[type][unit] = bmc_fwritep[type][unit];
	}

	/* fBAꂽꍇAꎞCWFNg */
	if (bmc_media[type][unit] != (BYTE)index) {
		bmc_media[type][unit] = (BYTE)index;
		bmc_teject[type][unit] = FALSE;
	}

	bmc_make_stat(type);
	return TRUE;
}

/*
 *	B77t@ĆAfBAі̎擾
 */
static int FASTCALL bmc_chkb77(int type, int unit)
{
	int i;
	int handle;
	int count;
	DWORD offset;
	DWORD len;
	BYTE buf[0x20];
#ifdef BMC_LOG
	LOG3(Normal, LGFMT "type:%d unit:%d",
				 LGARG, type, unit);
#endif

	/*  */
	for (i=0; i<BMC_MEDIAS; i++) {
		bmc_foffset[type][unit][i] = 0;
		bmc_name[type][unit][i][0] = '\0';
	}
	count = 0;
	offset = 0;

	/* t@CI[v */
	handle = file_open(bmc_fname[type][unit], OPEN_R);
	if (handle == -1) {
		return count;
	}

	/* fBA[v */
	while (count < BMC_MEDIAS) {
		/* V[N */
		if (!file_seek(handle, offset)) {
			file_close(handle);
			return count;
		}

		/* ǂݍ */
		if (!file_read(handle, buf, 0x0020)) {
			file_close(handle);
			return count;
		}

		/* ^Cv`FbNB32KB,128KBɂꂼΉ */
		if (((type == BMC_32) && (buf[0x001b] != 0x80)) ||
			((type == BMC_128) && (buf[0x001b] != 0x90))) {
			file_close(handle);
			return count;
		}

		/* ok,t@CAItZbgi[ */
		buf[17] = '\0';
		memcpy(bmc_name[type][unit][count], buf, 17);
		bmc_foffset[type][unit][count] = offset;

		/* next */
		len = 0;
		len |= buf[0x1f];
		len *= 256;
		len |= buf[0x1e];
		len *= 256;
		len |= buf[0x1d];
		len *= 256;
		len |= buf[0x1c];
		offset += len;
		count++;
	}

	/* ő僁fBAɒB */
	file_close(handle);
#ifdef BMC_LOG
	LOG3(Normal, LGFMT "handle:%d count:%d",
				 LGARG, handle, count);
#endif
	return count;
}

/*
 *	t@Cݒ
 */
int FASTCALL bmc_setfile(int type, int unit, char *fname)
{
	BOOL writep;
	int handle;
	DWORD fsize;
	int count;

	ASSERT((type == BMC_32) || (type == BMC_128));
	ASSERT((unit >= 0) && (unit < BMC_UNITS_128));

	/* mbgfBɂꍇ */
	if (fname == NULL) {
#ifdef BMC_LOG
	LOG4(Normal, LGFMT "type:%d unit:%d fname:%s",
				 LGARG, type, unit, fname);
#endif
		bmc_ready[type][unit] = BMC_TYPE_NOTREADY;
		bmc_fname[type][unit][0] = '\0';
		bmc_make_stat(type);
		return 1;
	}

	/* t@CI[vAt@CTCY𒲂ׂ */
	if (strlen(fname) >= sizeof(bmc_fname[type][unit])) {
#ifdef BMC_LOG
		LOG4(Normal, LGFMT "type:%d unit:%d fname:%s",
					 LGARG, type, unit, fname);
#endif
		bmc_ready[type][unit] = BMC_TYPE_NOTREADY;
		bmc_fname[type][unit][0] = '\0';
		bmc_make_stat(type);
		return 1;
	}
	writep = FALSE;
	handle = file_open(fname, OPEN_RW);
	if (handle == -1) {
		handle = file_open(fname, OPEN_R);
		if (handle == -1) {
			bmc_ready[type][unit] = BMC_TYPE_NOTREADY;
			bmc_make_stat(type);
			return 0;
		}
		writep = TRUE;
	}
	strcpy(bmc_fname[type][unit], fname);
	fsize = file_getsize(handle);
	file_close(handle);

	/*
	 * 32KBt@C
	 */
	if ((type == BMC_32) && (fsize == 32768)) {
#ifdef BMC_LOG
		LOG4(Normal, LGFMT "type:%d unit:%d fname:%s",
					 LGARG, type, unit, fname);
#endif
		/* ^CvAݑݒ */
		bmc_ready[type][unit] = BMC_TYPE_32;
		bmc_fwritep[type][unit] = writep;

		/* fBAݒ */
		if (!bmc_setmedia(type, unit, 0)) {
			bmc_ready[type][unit] = BMC_TYPE_NOTREADY;
			bmc_fname[type][unit][0] = '\0';
			bmc_make_stat(type);
			return 0;
		}

		/* BꎞCWFNg */
		bmc_teject[type][unit] = FALSE;
		bmc_medias[type][unit] = 1;
		bmc_make_stat(type);
		return 1;
	}

	/*
	 * 128KBt@C
	 */
	if ((type == BMC_128) && (fsize == 131072)) {
#ifdef BMC_LOG
		LOG4(Normal, LGFMT "type:%d unit:%d fname:%s",
					 LGARG, type, unit, fname);
#endif
		/* ^CvAݑݒ */
		bmc_ready[type][unit] = BMC_TYPE_128;
		bmc_fwritep[type][unit] = writep;

		/* fBAݒ */
		if (!bmc_setmedia(type, unit, 0)) {
			bmc_ready[type][unit] = BMC_TYPE_NOTREADY;
			bmc_fname[type][unit][0] = '\0';
			bmc_make_stat(type);
			return 0;
		}

		/* BꎞCWFNg */
		bmc_teject[type][unit] = FALSE;
		bmc_medias[type][unit] = 1;
		bmc_make_stat(type);
		return 1;
	}

	/*
	 * B77t@C
	 */
	bmc_ready[type][unit] = BMC_TYPE_B77;
	bmc_fwritep[type][unit] = writep;

	/* t@C */
	count = bmc_chkb77(type, unit);
	if (count != 0){
		/* fBAݒ */
		if (bmc_setmedia(type, unit, 0)) {
#ifdef BMC_LOG
			LOG4(Normal, LGFMT "type:%d unit:%d fname:%s",
						 LGARG, type, unit, fname);
#endif
			/* BꎞCWFNg */
			bmc_teject[type][unit] = FALSE;
			bmc_medias[type][unit] = (BYTE)count;
			bmc_make_stat(type);
			return count;
		}
	}

#ifdef BMC_LOG
	LOG4(Normal, LGFMT "type:%d unit:%d fname:%s",
				 LGARG, type, unit, fname);
#endif
	bmc_ready[type][unit] = BMC_TYPE_NOTREADY;
	bmc_fname[type][unit][0] = '\0';
	bmc_make_stat(type);
	return 0;
}

/*-[ BMCR}h EFCg[h ]---------------------------------------*/

/*
 *	BMC DataRequestCxg (WAIT)
 *	Cxg
 */
static BOOL FASTCALL bmc_drq_event(int type)
{
	/* Xgf[^`FbN */
	if (bmc_status[type] & (BYTE)(BMC_ST_RDA | BMC_ST_TDRA)) {
		if (type) {
			return bmc128_lost_event();
		}
		else {
			return bmc32_lost_event();
		}
	}

	/*  */
	switch ((BYTE)(bmc_command[type] & 0x0f)) {
		/* bubble read */
		case 0x01:
			bmc_status[type] |= (BYTE)BMC_ST_RDA;
			break;
		/* bubble write */
		case 0x02:
			bmc_status[type] |= (BYTE)BMC_ST_TDRA;
			break;
		/* initialize */
		case 0x04:
			if (type) {
				return bmc128_lost_event();
			}
			else {
				return bmc32_lost_event();
			}
	}
	bubble_notify(type);
#ifdef BMC_LOG
	LOG2(Normal, LGFMT "0x%02x", LGARG, (int)bmc_status[type]);
#endif

	return TRUE;
}

/*
 *	BMC 32KB DataRequestCxg (WAIT)
 */
static BOOL FASTCALL bmc32_drq_event(void)
{
	return bmc_drq_event(BMC_32);
}

/*
 *	BMC 128KB DataRequestCxg (WAIT)
 */
static BOOL FASTCALL bmc128_drq_event(void)
{
	return bmc_drq_event(BMC_128);
}

/*
 *	}`y[W
 *	Cxg
 */
static BOOL FASTCALL bmc_multi_event(int type)
{
	/* y[WWX^Up */
	bmc_pagereg[type]++;
	switch ((BYTE)(bmc_command[type] & 0x0f)) {
		/* bubble read */
		case 0x01:
			bmc_read_data(type);
			bmc_nowcnt[type] = 0;
			bmc_status[type] |= (BYTE)BMC_ST_RDA;
			break;
		/* bubble write */
		case 0x02:
			bmc_write_data(type);
			bmc_nowcnt[type] = 0;
			bmc_status[type] |= (BYTE)BMC_ST_TDRA;
			break;
	}
	bubble_notify(type);
#ifdef BMC_LOG
	LOG2(Normal, LGFMT "0x%02x", LGARG, (int)bmc_status[type]);
#endif

	/* Cxg폜ďI */
	if (type) {
		schedule_delevent(EVENT_BMC128_M);
	}
	else {
		schedule_delevent(EVENT_BMC_M);
	}
	return TRUE;
}

/*
 *	BMC 32KB
 *	}`y[W
 *	Cxg
 */
static BOOL FASTCALL bmc32_multi_event(void)
{
	return bmc_multi_event(BMC_32);
}

/*
 *	BMC 128KB
 *	}`y[W
 *	Cxg
 */
static BOOL FASTCALL bmc128_multi_event(void)
{
	return bmc_multi_event(BMC_128);
}

/*
 *	Xgf[^
 *	Cxg
 */
static BOOL FASTCALL bmc_lost_event(int type)
{
#ifdef BMC_LOG
	LOG2(Normal, LGFMT "dp:0x%08p", LGARG, (bmc_dataptr[type]));
	LOG2(Normal, LGFMT "ERR:0x%02x", LGARG, (int)(bmc_errorreg[type]));
	LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)(bmc_status[type]));
	LOG2(Normal, LGFMT "CMD:0x%02x", LGARG, (int)(bmc_command[type]));
	LOG2(Normal, LGFMT "PAG:0x%04x", LGARG, (int)(bmc_pagereg[type]));
	LOG2(Normal, LGFMT "CNT:0x%04x", LGARG, (int)(bmc_countreg[type]));
#endif
	if ((bmc_command[type] & 0x0f) == 0x04) {
		/* R}hł؂AXgf[^ */
		bmc_dataptr[type] = NULL;
		bmc_errorreg[type] = 0;
		bmc_make_stat(type);
		bmc_status[type] &= (BYTE)(~BMC_ST_BUSY);
		bmc_status[type] |= (BYTE)(BMC_ST_CME);
		bmc_access[type][0] = (BYTE)BMC_ACCESS_READY;
		bmc_access[type][1] = (BYTE)BMC_ACCESS_READY;
		if (type) {
			bmc_access[type][2] = (BYTE)BMC_ACCESS_READY;
			bmc_access[type][3] = (BYTE)BMC_ACCESS_READY;
		}
		bubble_notify(type);
#ifdef BMC_LOG
		LOG2(Normal, LGFMT "0x%02x", LGARG, (int)bmc_status[type]);
#endif
	}
	if (bmc_dataptr[type]) {
		/* R}hł؂AXgf[^ */
		bmc_dataptr[type] = NULL;
		bmc_errorreg[type] = (BYTE)BMC_ES_PAGEOVER;
		bmc_make_stat(type);
		bmc_status[type] &= (BYTE)(~BMC_ST_BUSY);
		bmc_status[type] |= (BYTE)(BMC_ST_CME | BMC_ST_ERROR);
		bmc_access[type][bmc_unit[type]] = (BYTE)BMC_ACCESS_READY;
		bubble_notify(type);
#ifdef BMC_LOG
		LOG2(Normal, LGFMT "0x%02x", LGARG, (int)bmc_status[type]);
#endif
	}

	/* Cxg폜ďI */
	if (type) {
		schedule_delevent(EVENT_BMC128_L);
	}
	else {
		schedule_delevent(EVENT_BMC_L);
	}
	return TRUE;
}

/*
 *	BMC 32KB Xgf[^
 *	Cxg
 */
static BOOL FASTCALL bmc32_lost_event(void)
{
	return bmc_lost_event(BMC_32);
}

/*
 *	BMC 128KB Xgf[^
 *	Cxg
 */
static BOOL FASTCALL bmc128_lost_event(void)
{
	return bmc_lost_event(BMC_128);
}

/*-[ BMCR}h ]----------------------------------------------------------*/

/*
 *	Xe[^X쐬
 */
static void FASTCALL bmc_make_stat(int type)
{
	/* Lȃjbg */
	if (bmc_ready[type][bmc_unit[type]] == BMC_TYPE_NOTREADY) {
		bmc_status[type] &= (BYTE)(~BMC_ST_READY);
	}
	else {
		bmc_status[type] |= (BYTE)BMC_ST_READY;
	}

	/* ꎞCWFNg */
	if (bmc_teject[type][bmc_unit[type]]) {
		bmc_status[type] &= (BYTE)(~BMC_ST_READY);
	}

	/* CgveNg */
	if (bmc_writep[type][bmc_unit[type]]) {
		bmc_status[type] |= (BYTE)BMC_ST_WRITEP;
	}
	else {
		bmc_status[type] &= (BYTE)(~BMC_ST_WRITEP);
	}
}

/*
 *	ou Rg[
 */
static void FASTCALL bmc_initialize(int type)
{
	/*  */
	bmc_status[type] = (BYTE)BMC_ST_NONE;
	bmc_errorreg[type] = (BYTE)0;

	/* Abvf[g(f[^WX^1ɂ) */
	bmc_datareg[type] = (BYTE)1;
	bmc_pagereg[type] = 0;
	bmc_countreg[type] = 0;
	bmc_totalcnt[type] = 0;
	bmc_nowcnt[type] = 0;

	if (bmc_wait) {
		if (type) {
			schedule_setevent(EVENT_BMC128_L, BMC_LOST_TIME * 100, bmc128_drq_event);
		}
		else {
			schedule_setevent(EVENT_BMC_L, BMC_LOST_TIME * 100, bmc32_drq_event);
		}
	}

	/* Xe[^Xݒ肷 */
	bmc_status[type] |= (BYTE)BMC_ST_BUSY;
	bmc_make_stat(type);
	bubble_notify(type);

	/* ANZX(READY) */
	if (bmc_ready[type][0] != BMC_TYPE_NOTREADY) {
		bmc_access[type][0] = (BYTE)BMC_ACCESS_READ;
	}
	if (bmc_ready[type][1] != BMC_TYPE_NOTREADY) {
		bmc_access[type][1] = (BYTE)BMC_ACCESS_READ;
	}
	if (type) {
		if (bmc_ready[type][2] != BMC_TYPE_NOTREADY) {
			bmc_access[type][2] = (BYTE)BMC_ACCESS_READ;
		}
		if (bmc_ready[type][3] != BMC_TYPE_NOTREADY) {
			bmc_access[type][3] = (BYTE)BMC_ACCESS_READ;
		}
	}
}

/*
 *	ou Rg[
 */
static void FASTCALL bmc_force_initialize(int type)
{
	/*  */
	if (type) {
		schedule_delevent(EVENT_BMC128_L);
	}
	else {
		schedule_delevent(EVENT_BMC_L);
	}
	bmc_datareg[type] = (BYTE)0;
	bmc_status[type] = (BYTE)BMC_ST_NONE;
	bmc_errorreg[type] = (BYTE)0;

	/* Xe[^Xݒ肷 */
	bmc_make_stat(type);

	/* ANZX(READY) */
	bmc_access[type][bmc_unit[type]] = (BYTE)BMC_ACCESS_READY;
}

/*
 *	READ/WRITE Tu
 */
static BOOL FASTCALL bmc_rw_sub(int type)
{
	bmc_status[type] = (BYTE)BMC_ST_NONE;
	bmc_errorreg[type] = (BYTE)0;

	/* y[WAhX`FbN */
	if (type == BMC_32) {
		if ((bmc_unit[type] >= BMC_UNITS_32) ||
			(bmc_pagereg[type] >= (bmc_max_addr[type] + 1) * 2)) {
			LOG2(Warning, "unit:%d page:%d", bmc_unit[type], bmc_pagereg[type]);
			bmc_status[type] |= (BYTE)(BMC_ST_CME | BMC_ST_ERROR);
			bmc_errorreg[type] |= (BYTE)BMC_ES_PAGEOVER;
			bmc_make_stat(type);
			return FALSE;
		}
	}
	else {
		if ((bmc_unit[type] >= BMC_UNITS_128) ||
			((bmc_pagereg[type] & 0x3fff) >= (bmc_max_addr[type] + 1))) {
			LOG2(Warning, "unit:%d page:%d", bmc_unit[type], bmc_pagereg[type]);
			bmc_status[type] |= (BYTE)(BMC_ST_CME | BMC_ST_ERROR);
			bmc_errorreg[type] |= (BYTE)BMC_ES_PAGEOVER;
			bmc_make_stat(type);
			return FALSE;
		}
	}

	/* NOT READY`FbN */
	if ((bmc_ready[type][bmc_unit[type]] == BMC_TYPE_NOTREADY) ||
		bmc_teject[type][bmc_unit[type]]) {
		bmc_status[type] |= (BYTE)(BMC_ST_CME | BMC_ST_ERROR);
		bmc_errorreg[type] |= (BYTE)BMC_ES_EJECT;
		bmc_make_stat(type);
		return FALSE;
	}

	return TRUE;
}

/*
 *	y[Wǂݍ݊Jn
 */
static void FASTCALL bmc_read_data(int type)
{
	/* {`FbN */
	if (!bmc_rw_sub(type)) {
		return;
	}

	/* f[^|C^AJE^ݒ */
	bmc_dataptr[type] = &bmc_buffer[type][0];
	bmc_offset[type] = 0;
	bmc_totalcnt[type] = bmc_page_size[type];
	bmc_nowcnt[type] = 0;

	/* f[^obt@ǂݍ */
	if (!bmc_readbuf(type)) {
		bmc_status[type] |= (BYTE)(BMC_ST_CME | BMC_ST_ERROR);
		bmc_errorreg[type] |= (BYTE)BMC_ES_NOMAKER;
		bmc_access[type][bmc_unit[type]] = (BYTE)BMC_ACCESS_READ;
#ifdef BMC_LOG
		LOG1(Normal, LGFMT, LGARG);
#endif
		return;
	}

	/* ŏ̃f[^ݒ */
	bmc_status[type] |= (BYTE)BMC_ST_BUSY;
	bmc_datareg[type] = bmc_dataptr[type][0];
	if (bmc_wait) {
		if (type) {
			schedule_setevent(EVENT_BMC128_L, BMC_LOST_TIME * 48, bmc128_drq_event);
		}
		else {
			schedule_setevent(EVENT_BMC_L, BMC_LOST_TIME * 48, bmc32_drq_event);
		}
	}
	else {
		bmc_status[type] |= (BYTE)BMC_ST_RDA;
	}

	/* ANZX(READ) */
	bmc_access[type][bmc_unit[type]] = (BYTE)BMC_ACCESS_READ;

	/* Xgf[^Cxgݒ */
	if (!bmc_wait) {
		if (type) {
			schedule_setevent(EVENT_BMC128_L, 30 * 1000, bmc128_lost_event);
		}
		else {
			schedule_setevent(EVENT_BMC_L, 30 * 1000, bmc32_lost_event);
		}
	}
#ifdef BMC_LOG
	LOG1(Normal, LGFMT, LGARG);
#endif
}

/*
 *	y[Wݍ݊Jn
 */
static void FASTCALL bmc_write_data(int type)
{
	/* {`FbN */
	if (!bmc_rw_sub(type)) {
		return;
	}

	/* f[^|C^AJE^ݒ */
	bmc_dataptr[type] = &bmc_buffer[type][0];
	bmc_offset[type] = 0;
	bmc_totalcnt[type] = bmc_page_size[type];
	bmc_nowcnt[type] = 0;

	/* WRITE PROTECT`FbN */
	if (bmc_writep[type][bmc_unit[type]] != 0) {
		bmc_status[type] |= (BYTE)(BMC_ST_CME | BMC_ST_ERROR);
		bmc_make_stat(type);
		return;
	}

	/* Xe[^Xݒ */
	bmc_status[type] |= (BYTE)BMC_ST_BUSY;
	if (bmc_wait) {
		if (type) {
			schedule_setevent(EVENT_BMC128_L, BMC_LOST_TIME * 48, bmc128_drq_event);
		}
		else {
			schedule_setevent(EVENT_BMC_L, BMC_LOST_TIME * 48, bmc32_drq_event);
		}
	}
	else {
		bmc_status[type] |= (BYTE)BMC_ST_TDRA;
	}

	/* ANZX(WRITE) */
	bmc_access[type][bmc_unit[type]] = (BYTE)BMC_ACCESS_WRITE;

	/* Xgf[^Cxgݒ */
	if (!bmc_wait) {
		if (type) {
			schedule_setevent(EVENT_BMC128_L, 30 * 1000, bmc128_lost_event);
		}
		else {
			schedule_setevent(EVENT_BMC_L, 30 * 1000, bmc32_lost_event);
		}
	}
}

/*
 *	R}h
 */
static void FASTCALL bmc_process_cmd(int type)
{
	BYTE low;

	low = (BYTE)(bmc_command[type] & 0x0f);

	/* BUSYforce initializeȊOȂ */
	if ((bmc_status[type] & BMC_ST_BUSY) &&
		(low != 0x0f)) {
		return;
	}

	/* EFCgtOݒ */
	bmc_wait = fdc_waitmode;

	/* f[^]sĂ΁A~߂ */
	bmc_dataptr[type] = NULL;

	/* R}hsɃy[W烆jbgZo */
	if (type == BMC_32) {
		bmc_unit[type] = (BYTE)(bmc_pagereg[type] >> 10);
	}
	else {
		bmc_unit[type] = (BYTE)(bmc_pagereg[type] >> 14);
	}

	/*  */
	switch (low) {
		/* bubble read */
		case 0x01:
#ifdef BMC_LOG
			LOG0(Normal, "BUBBLE READ(0x01)R}h");
#endif
			bmc_read_data(type);
			break;
		/* bubble write */
		case 0x02:
#ifdef BMC_LOG
			LOG0(Normal, "BUBBLE WRITE(0x02)R}h");
#endif
			bmc_write_data(type);
			break;
		/* initialize */
		case 0x04:
#ifdef BMC_LOG
			LOG0(Normal, "INITIALIZE(0x04)R}h");
#endif
			bmc_initialize(type);
			break;
		/* ? */
		case 0x00:
		case 0x07:
		case 0x08:
#ifdef BMC_LOG
			LOG1(Normal, "????(0x%02x)R}h", low);
#endif
			/* Xe[^Xݒ肷 */
			bmc_status[type] = (BYTE)(BMC_ST_CME | BMC_ST_NONE);
			bmc_errorreg[type] = (BYTE)0;
			bmc_make_stat(type);
			break;
		/* (bubble read/write?) */
		case 0x09:
		case 0x0a:
		case 0x0b:
#ifdef BMC_LOG
			LOG1(Normal, "????(0x%02x)R}h", low);
#endif
			/* Xe[^Xݒ肷 */
			bmc_status[type] = (BYTE)(BMC_ST_CME | BMC_ST_NONE | BMC_ST_ERROR);
			bmc_errorreg[type] = (BYTE)BMC_ES_PAGEOVER;
			break;
		/* ? */
		case 0x0c:
#ifdef BMC_LOG
			LOG1(Normal, "????(0x%02x)R}h", low);
#endif
			/* Xe[^Xݒ肷 */
			bmc_datareg[type] = 0;
			bmc_status[type] = (BYTE)(BMC_ST_TDRA | BMC_ST_NONE | BMC_ST_BUSY);
			bmc_errorreg[type] = (BYTE)0;
			bmc_make_stat(type);
			break;
		/* force initialize */
		case 0x0f:
#ifdef BMC_LOG
			LOG0(Normal, "INITIALIZE(0x0f)R}h");
#endif
			bmc_force_initialize(type);
			break;
		/* undefined */
		default:
#ifdef BMC_LOG
			LOG1(Normal, "UNDEFINED(0x%02x)R}h", low);
#endif
			/* Xe[^Xݒ肷 */
			bmc_status[type] = (BYTE)(BMC_ST_CME | BMC_ST_NONE | BMC_ST_ERROR);
			bmc_errorreg[type] = (BYTE)BMC_ES_UNDEF;
			break;
	}

#ifdef BMC_LOG
	LOG2(Normal, LGFMT "0x%02x", LGARG, (int)bmc_status[type]);
#endif
	bubble_notify(type);

	/* READYȂ烌WX^ */
	if (!(bmc_status[type] & BMC_ST_BUSY)) {
		bmc_command[type] &= (BYTE)0xf0;
		bmc_pagereg[type] = 0;
		bmc_countreg[type] = 0;
	}
}

/*
 *	ou Rg[
 *	PoCgǂݏo
 */
BOOL FASTCALL bmc_readb(WORD addr, BYTE *dat)
{
	/* 32KB */
	int type = BMC_32;

	/* AhX`FbN */
	if (((addr & 0xfff8) != 0xfd10) && ((addr & 0xfff8) != 0xfdd0)) {
		return FALSE;
	}

	/* 128KB */
	if ((addr & 0xfff8) == 0xfdd0) {
		type = BMC_128;
	}

	/* LE`FbN */
	if (!bmc_enable[type]) {
		return FALSE;
	}

	/* 32KBFM-8[h */
	if ((model_type != MODEL_FM8) && (type == BMC_32)) {
		/* FM-7/77B[hŗLɂĂ݂ */
		if (!bmc_secret_flag) {
			/* ouJZbggpƂ̂Xe[g̑΍ */
			if (!bmc_use[BMC_32]) {
				return FALSE;
			}
		}

		/* OPN or }EXZbgLI/ÔŖ */
		if (opn_enable || (mos_port == 3)) {
			return FALSE;
		}
	}

	switch (addr) {
		/* f[^WX^(BDATA) */
		case 0xfd10:
		case 0xfdd0:
			*dat = bmc_datareg[type];
#ifdef BMC_LOG
			LOG4(Normal, LGFMT "pc:0x%04x addr:0x%04x datareg:0x%02x", LGARG, (int)(maincpu.pc), (int)addr, (int)*dat);
			LOG5(Normal, LGFMT "status:0x%02x countreg:0x%02x pagereg:0x%02x max_addr:0x%02x", LGARG, bmc_status[type], bmc_countreg[type], bmc_pagereg[type], bmc_max_addr[type]);
#endif
			/* JE^ */
			if (bmc_dataptr[type]) {
#ifdef BMC_LOG
				LOG2(Normal, LGFMT "CNT:0x%04x", LGARG, (int)(bmc_nowcnt[type]));
#endif
				bmc_nowcnt[type]++;
				if (bmc_nowcnt[type] == bmc_totalcnt[type]) {
					if (bmc_wait) {
						if (type) {
							schedule_delevent(EVENT_BMC128_L);
						}
						else {
							schedule_delevent(EVENT_BMC_L);
						}
					}
					bmc_status[type] &= (BYTE)(~BMC_ST_BUSY);
					bmc_status[type] &= (BYTE)(~BMC_ST_RDA);
					bmc_status[type] |= (BYTE)BMC_ST_CME;

					bmc_countreg[type]--;
					if ((bmc_countreg[type] > 0) &&
						((bmc_pagereg[type] & bmc_max_addr[type]) < bmc_max_addr[type])) {
						/* }`y[W */
						bmc_status[type] |= (BYTE)BMC_ST_BUSY;
						bmc_status[type] &= (BYTE)(~BMC_ST_CME);
						bmc_dataptr[type] = NULL;
						if (type) {
							schedule_setevent(EVENT_BMC128_M, 30, bmc128_multi_event);
						}
						else {
							schedule_setevent(EVENT_BMC_M, 30, bmc32_multi_event);
						}

#ifdef BMC_LOG
						LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)bmc_status[type]);
#endif
						bubble_notify(type);
						return TRUE;
					}
					/* VOy[W or }`y[WI */
					bmc_dataptr[type] = NULL;

					/* ANZX(READY) */
					bmc_access[type][bmc_unit[type]] = (BYTE)BMC_ACCESS_READY;
#ifdef BMC_LOG
					LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)bmc_status[type]);
					LOG2(Normal, LGFMT "CMD:0x%02x", LGARG, (int)(bmc_command[type]));
					LOG2(Normal, LGFMT "PAG:0x%04x", LGARG, (int)(bmc_pagereg[type]));
					LOG2(Normal, LGFMT "CNT:0x%04x", LGARG, (int)(bmc_countreg[type]));
					LOG2(Normal, LGFMT "dp:0x%08p", LGARG, (bmc_dataptr[type]));
#endif
					bubble_notify(type);

					/* WX^ */
					bmc_command[type] &= (BYTE)0xf0;
					bmc_pagereg[type] = 0;
					bmc_countreg[type] = 0;
				}
				else {
					bmc_datareg[type] = bmc_dataptr[type][bmc_nowcnt[type]];
					if (bmc_wait) {
						if (type) {
							schedule_setevent(EVENT_BMC128_L, BMC_LOST_TIME, bmc128_drq_event);
						}
						else {
							schedule_setevent(EVENT_BMC_L, BMC_LOST_TIME, bmc32_drq_event);
						}
						bmc_status[type] &= (BYTE)(~BMC_ST_RDA);
					}
					else {
						bmc_status[type] |= (BYTE)BMC_ST_RDA;
					}
#ifdef BMC_LOG
					LOG2(Normal, LGFMT "DAT:0x%02x", LGARG, (int)bmc_datareg[type]);
					LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)bmc_status[type]);
#endif
				}
			}
			return TRUE;

		/* R}hWX^(BCMD) */
		case 0xfd11:
		case 0xfdd1:
			*dat = bmc_command[type];
#ifdef BMC_LOG
			LOG3(Normal, LGFMT "0x%04x 0x%02x", LGARG, (int)addr, (int)*dat);
#endif
			return TRUE;

		/* Xe[^XWX^(BSTAT) */
		case 0xfd12:
		case 0xfdd2:
			bmc_make_stat(type);
			*dat = bmc_status[type];
#ifdef BMC_LOG
			LOG4(Normal, LGFMT "pc:0x%04x addr:0x%04x status:0x%02x", LGARG, (int)(maincpu.pc), (int)addr, (int)*dat);
#endif
			if (bmc_wait) {
				return TRUE;
			}
			/* BUSY */
			if ((bmc_status[type] & BMC_ST_BUSY) &&
				(bmc_dataptr[type] == NULL)) {
				/* BUSYtO𗎂Ƃ */
				bmc_status[type] &= (BYTE)(~BMC_ST_BUSY);
				bmc_access[type][bmc_unit[type]] = (BYTE)BMC_ACCESS_READY;
			}
			/* CAN READ */
			if (((bmc_command[type] & 0x0f) == 0x01) &&
				(bmc_dataptr[type]) &&
				!(bmc_status[type] & BMC_ST_RDA)) {
				/* CAN READtO𗧂Ă */
				bmc_status[type] |= (BYTE)BMC_ST_RDA;
			}
			/* CAN WRITE */
			if (((bmc_command[type] & 0x0f) == 0x02) &&
				(bmc_dataptr[type]) &&
				!(bmc_status[type] & BMC_ST_TDRA)) {
				/* CAN WRITEtO𗧂Ă */
				bmc_status[type] |= (BYTE)BMC_ST_TDRA;
			}
			/* initialize㏈ */
			if ((bmc_command[type] & 0x0f) == 0x04) {
				/* COMMAND ENDtO𗧂Ă */
				bmc_status[type] |= (BYTE)(BMC_ST_CME);
				if (bmc_ready[type][0] == BMC_ACCESS_READ) {
					bmc_access[type][0] = (BYTE)BMC_ACCESS_READY;
				}
				if (bmc_ready[type][1] == BMC_ACCESS_READ) {
					bmc_access[type][1] = (BYTE)BMC_ACCESS_READY;
				}
				if (type) {
					if (bmc_ready[type][2] == BMC_ACCESS_READ) {
						bmc_access[type][2] = (BYTE)BMC_ACCESS_READY;
					}
					if (bmc_ready[type][3] == BMC_ACCESS_READ) {
						bmc_access[type][3] = (BYTE)BMC_ACCESS_READY;
					}
				}
			}
			bubble_notify(type);
			return TRUE;

		/* G[Xe[^XWX^(BERRST) */
		case 0xfd13:
		case 0xfdd3:
			*dat = bmc_errorreg[type];

			/* NOT BUSYȂ */
			if (!(bmc_status[type] & BMC_ST_BUSY)) {
				/* G[Xe[^X𗎂Ƃ */
				bmc_errorreg[type] = 0;

				/* ERROR ANALYSIStO𗎂Ƃ */
				bmc_status[type] &= (BYTE)(~BMC_ST_ERROR);

				/* COMMAND ENDtO𗎂Ƃ */
				bmc_status[type] &= (BYTE)(~BMC_ST_CME);
			}
#ifdef BMC_LOG
			LOG3(Normal, LGFMT "0x%04x 0x%02x", LGARG, (int)addr, (int)*dat);
#endif
			return TRUE;

		/* y[WAhXWX^H(BPGADH) */
		case 0xfd14:
		case 0xfdd4:
			*dat = (BYTE)(bmc_pagereg[type] >> 8);
#ifdef BMC_LOG
			LOG3(Normal, LGFMT "0x%04x 0x%02x", LGARG, (int)addr, (int)*dat);
#endif
			return TRUE;

		/* y[WAhXWX^L(BPGADL) */
		case 0xfd15:
		case 0xfdd5:
			*dat = (BYTE)(bmc_pagereg[type] & 0x00ff);
#ifdef BMC_LOG
			LOG3(Normal, LGFMT "0x%04x 0x%02x", LGARG, (int)addr, (int)*dat);
#endif
			return TRUE;

		/* y[WJEgWX^H(BPGCTH) */
		case 0xfd16:
		case 0xfdd6:
			*dat = (BYTE)(bmc_countreg[type] >> 8);
#ifdef BMC_LOG
			LOG3(Normal, LGFMT "0x%04x 0x%02x", LGARG, (int)addr, (int)*dat);
#endif
			return TRUE;

		/* y[WJEgWX^L(BPGCTL) */
		case 0xfd17:
		case 0xfdd7:
			*dat = (BYTE)(bmc_countreg[type] & 0x00ff);
#ifdef BMC_LOG
			LOG3(Normal, LGFMT "0x%04x 0x%02x", LGARG, (int)addr, (int)*dat);
#endif
			return TRUE;
	}

	/* 0Ԃ */
	*dat = 0;
	return TRUE;
}

/*
 *	ou Rg[
 *	PoCg
 */
BOOL FASTCALL bmc_writeb(WORD addr, BYTE dat)
{
	/* 32KB */
	int type = BMC_32;

	/* AhX`FbN */
	if (((addr & 0xfff8) != 0xfd10) && ((addr & 0xfff8) != 0xfdd0)) {
		return FALSE;
	}

	/* 128KB */
	if ((addr & 0xfff8) == 0xfdd0) {
		type = BMC_128;
	}

	/* LE`FbN */
	if (!bmc_enable[type]) {
		return FALSE;
	}

	/* 32KBFM-8[h */
	if ((model_type != MODEL_FM8) && (type == BMC_32)) {
		/* FM-7/77B[hŗLɂĂ݂ */
		if (!bmc_secret_flag) {
			/* ouJZbggpƂ̂Xe[g̑΍ */
			if (!bmc_use[BMC_32]) {
				return FALSE;
			}
		}

		/* OPN or }EXZbgLI/ÔŖ */
		if (opn_enable || (mos_port == 3)) {
			return FALSE;
		}
	}

	bmc_use[type] = TRUE;

#ifdef BMC_LOG
	LOG3(Normal, LGFMT "0x%04x 0x%02x", LGARG, (int)addr, (int)dat);
#endif
	switch (addr) {
		/* f[^WX^(BDATA) */
		case 0xfd10:
		case 0xfdd0:
			bmc_datareg[type] = dat;
			/* JE^ */
			if (bmc_dataptr[type]) {
				bmc_dataptr[type][bmc_nowcnt[type]] = bmc_datareg[type];
				bmc_nowcnt[type]++;
				if (bmc_nowcnt[type] == bmc_totalcnt[type]) {
					if (bmc_wait) {
						if (type) {
							schedule_delevent(EVENT_BMC128_L);
						}
						else {
							schedule_delevent(EVENT_BMC_L);
						}
					}
					bmc_status[type] &= (BYTE)(~BMC_ST_BUSY);
					bmc_status[type] &= (BYTE)(~BMC_ST_TDRA);
					bmc_status[type] |= (BYTE)BMC_ST_CME;

					/* Cgy[W */
					if (!bmc_write_page(type)) {
						bmc_status[type] |= (BYTE)(BMC_ST_CME | BMC_ST_ERROR);
						bmc_errorreg[type] |= (BYTE)BMC_ES_NOMAKER;
					}

					bmc_countreg[type]--;
					if ((bmc_countreg[type] > 0) &&
						((bmc_pagereg[type] & bmc_max_addr[type]) < bmc_max_addr[type])) {
						/* }`y[W */
						bmc_status[type] |= (BYTE)BMC_ST_BUSY;
						bmc_status[type] &= (BYTE)(~BMC_ST_CME);
						bmc_dataptr[type] = NULL;
						if (type) {
							schedule_setevent(EVENT_BMC128_M, 30, bmc128_multi_event);
						}
						else {
							schedule_setevent(EVENT_BMC_M, 30, bmc32_multi_event);
						}

#ifdef BMC_LOG
						LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)bmc_status[type]);
#endif
						bubble_notify(type);
						return TRUE;
					}
					/* VOy[W or }`y[WI */
					bmc_dataptr[type] = NULL;

					/* ANZX(READY) */
					bmc_access[type][bmc_unit[type]] = (BYTE)BMC_ACCESS_READY;
#ifdef BMC_LOG
					LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)bmc_status[type]);
#endif
					bubble_notify(type);

					/* WX^ */
					bmc_command[type] &= (BYTE)0xf0;
					bmc_pagereg[type] = 0;
					bmc_countreg[type] = 0;
				}
				else {
					if (bmc_wait) {
						if (type) {
							schedule_setevent(EVENT_BMC128_L, BMC_LOST_TIME, bmc128_drq_event);
						}
						else {
							schedule_setevent(EVENT_BMC_L, BMC_LOST_TIME, bmc32_drq_event);
						}
						bmc_status[type] &= (BYTE)(~BMC_ST_TDRA);
					}
					else {
						bmc_status[type] |= (BYTE)BMC_ST_TDRA;
					}
				}
			}
			return TRUE;

		/* R}hWX^(BCMD) */
		case 0xfd11:
		case 0xfdd1:
			bmc_command[type] = dat;
			bmc_process_cmd(type);
			return TRUE;

		/* y[WAhXWX^H(BPGADH) */
		case 0xfd14:
		case 0xfdd4:
			bmc_pagereg[type] &= 0x00ff;
			bmc_pagereg[type] |= (WORD)(dat << 8);
#ifdef BMC_LOG
			LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)bmc_status[type]);
#endif
			bubble_notify(type);
			return TRUE;

		/* y[WAhXWX^L(BPGADL) */
		case 0xfd15:
		case 0xfdd5:
			bmc_pagereg[type] &= 0xff00;
			bmc_pagereg[type] |= dat;
#ifdef BMC_LOG
			LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)bmc_status[type]);
#endif
			bubble_notify(type);
			return TRUE;

		/* y[WJEgWX^H(BPGCTH) */
		case 0xfd16:
		case 0xfdd6:
			bmc_countreg[type] &= 0x00ff;
			bmc_countreg[type] |= (WORD)(dat << 8);
#ifdef BMC_LOG
			LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)bmc_status[type]);
#endif
			bubble_notify(type);
			return TRUE;

		/* y[WJEgWX^L(BPGCTL) */
		case 0xfd17:
		case 0xfdd7:
			bmc_countreg[type] &= 0xff00;
			bmc_countreg[type] |= dat;
#ifdef BMC_LOG
			LOG2(Normal, LGFMT "STA:0x%02x", LGARG, (int)bmc_status[type]);
#endif
			bubble_notify(type);
			return TRUE;
	}

	return FALSE;
}

/*
 *	ou Rg[
 *	Z[u
 */
BOOL FASTCALL bmc_save(int fileh)
{
	int i, j, bmc_units;
	DWORD size;

	LOG0(Normal, "Z[u");

	for (i=0; i<2; i++) {
		if (i == BMC_32) {
			bmc_units = BMC_UNITS_32;
			size = (DWORD)bmc_page_size[i];
		}
		else {
			bmc_units = BMC_UNITS_128;
			size = (DWORD)bmc_page_size[i];
		}

		/* t@C֌WɎĂ */
		for (j=0; j<bmc_units; j++) {
			if (!file_byte_write(fileh, bmc_ready[i][j])) {
				return FALSE;
			}
		}
		for (j=0; j<bmc_units; j++) {
			if (!file_write(fileh, (BYTE*)bmc_fname[i][j], 256 + 1)) {
				return FALSE;
			}
		}
		for (j=0; j<bmc_units; j++) {
			if (!file_byte_write(fileh, bmc_media[i][j])) {
				return FALSE;
			}
		}

		for (j=0; j<bmc_units; j++) {
			if (!file_bool_write(fileh, bmc_teject[i][j])) {
				return FALSE;
			}
		}

		/* t@CXe[^X */
		if (!file_write(fileh, bmc_buffer[i], size)) {
			return FALSE;
		}

		/* bmc_dataptr͊Ɉˑf[^|C^ */
		if (!bmc_dataptr[i]) {
			if (!file_word_write(fileh, (WORD)size)) {
				return FALSE;
			}
		}
		else {
			if (!file_word_write(fileh, (WORD)(bmc_dataptr[i] - &bmc_buffer[i][0]))) {
				return FALSE;
			}
		}

		if (!file_dword_write(fileh, bmc_offset[i])) {
			return FALSE;
		}

		/* I/O */
		if (!file_byte_write(fileh, bmc_datareg[i])) {
			return FALSE;
		}
		if (!file_byte_write(fileh, bmc_command[i])) {
			return FALSE;
		}
		if (!file_byte_write(fileh, bmc_status[i])) {
			return FALSE;
		}
		if (!file_byte_write(fileh, bmc_errorreg[i])) {
			return FALSE;
		}
		if (!file_word_write(fileh, bmc_pagereg[i])) {
			return FALSE;
		}
		if (!file_word_write(fileh, bmc_countreg[i])) {
			return FALSE;
		}

		/* ̑ */
		if (!file_word_write(fileh, bmc_totalcnt[i])) {
			return FALSE;
		}
		if (!file_word_write(fileh, bmc_nowcnt[i])) {
			return FALSE;
		}
		for (j=0; j<bmc_units; j++) {
			if (!file_byte_write(fileh, bmc_access[i][j])) {
				return FALSE;
			}
		}

		/* LE`FbN */
		if (!file_bool_write(fileh, bmc_enable[i])) {
			return FALSE;
		}
		if (!file_bool_write(fileh, bmc_use[i])) {
			return FALSE;
		}
	}

	if (!file_bool_write(fileh, bmc_wait)) {
		return FALSE;
	}

	return TRUE;
}

/*
 *	ou Rg[
 *	[h
 */
BOOL FASTCALL bmc_load(int fileh, int ver)
{
	int i, j, bmc_units, bmc_types;
	BYTE ready[2][BMC_UNITS_128];
	char fname[2][BMC_UNITS_128][256 + 1];
	BYTE media[2][BMC_UNITS_128];
	WORD offset;
	DWORD size;
	int pathlen;

	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	LOG0(Normal, "[h");

	if ((ver < 307) ||
		((ver >= 400) && (ver < 403))) {
		bmc_init();
		bmc_reset();
		return TRUE;
	}

	/* 128Kou̗L */
	if (ver >= 400) {
		bmc_types = 2;
	}
	else {
		bmc_types = 1;
	}

	/* t@C̍ő啶 */
	if (ver != 403) {
		pathlen = 256;
	}
	else {
		pathlen = 128;
	}

	for (i=0; i<bmc_types; i++) {
		if (i == BMC_32) {
			bmc_units = BMC_UNITS_32;
			size = (DWORD)bmc_page_size[i];
		}
		else {
			bmc_units = BMC_UNITS_128;
			size = (DWORD)bmc_page_size[i];
		}

		/* t@C֌WɎĂ */
		for (j=0; j<bmc_units; j++) {
			if (!file_byte_read(fileh, &ready[i][j])) {
				return FALSE;
			}
		}
		for (j=0; j<bmc_units; j++) {
			if (!file_read(fileh, (BYTE*)fname[i][j], pathlen + 1)) {
				return FALSE;
			}
		}
		if (((ver >= 308) && (ver <= 399)) ||
			(ver >= 409)) {
			for (j=0; j<bmc_units; j++) {
				if (!file_byte_read(fileh, &media[i][j])) {
					return FALSE;
				}
			}
		}
		else {
			for (j=0; j<bmc_units; j++) {
				media[i][j] = 0;
			}
		}

		/* ă}Eg݂ */
		for (j=0; j<bmc_units; j++) {
			bmc_setfile(i, j, NULL);
			if (ready[i][j] != BMC_TYPE_NOTREADY) {
				bmc_setfile(i, j, fname[i][j]);
				if (bmc_ready[i][j] != BMC_TYPE_NOTREADY) {
					if (bmc_medias[i][j] >= (media[i][j] + 1)) {
						bmc_setmedia(i, j, media[i][j]);
					}
				}
			}
		}

		for (j=0; j<bmc_units; j++) {
			if (!file_bool_read(fileh, &bmc_teject[i][j])) {
				return FALSE;
			}
		}

		/* t@CXe[^X */
		if (!file_read(fileh, bmc_buffer[i], size)) {
			return FALSE;
		}

		/* bmc_dataptr͊Ɉˑf[^|C^ */
		if (!file_word_read(fileh, &offset)) {
			return FALSE;
		}
		if (offset >= (WORD)size) {
			bmc_dataptr[i] = NULL;
		}
		else {
			bmc_dataptr[i] = &bmc_buffer[i][offset];
		}

		if (!file_dword_read(fileh, &bmc_offset[i])) {
			return FALSE;
		}

		/* I/O */
		if (!file_byte_read(fileh, &bmc_datareg[i])) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &bmc_command[i])) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &bmc_status[i])) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &bmc_errorreg[i])) {
			return FALSE;
		}
		if (!file_word_read(fileh, &bmc_pagereg[i])) {
			return FALSE;
		}
		if (!file_word_read(fileh, &bmc_countreg[i])) {
			return FALSE;
		}

		/* ̑ */
		if (!file_word_read(fileh, &bmc_totalcnt[i])) {
			return FALSE;
		}
		if (!file_word_read(fileh, &bmc_nowcnt[i])) {
			return FALSE;
		}
		for (j=0; j<bmc_units; j++) {
			if (!file_byte_read(fileh, &bmc_access[i][j])) {
				return FALSE;
			}
		}

		/* y[W烆jbgZo */
		if (i == BMC_32) {
			bmc_unit[i] = (BYTE)(bmc_pagereg[i] >> 10);
		}
		else {
			bmc_unit[i] = (BYTE)(bmc_pagereg[i] >> 14);
		}

		/* LE`FbN */
		if (!file_bool_read(fileh, &bmc_enable[i])) {
			return FALSE;
		}

		if (((ver >= 307) && (ver <= 399)) ||
			(ver >= 405)) {
			if (!file_bool_read(fileh, &bmc_use[i])) {
				return FALSE;
			}
		}
		else {
			bmc_use[i] = bmc_enable[i];
		}

		/* Xe[^Xf */
		bubble_notify(i);
	}

	if (((ver >= 307) && (ver <= 399)) ||
		(ver >= 404)) {
		if (!file_bool_read(fileh, &bmc_wait)) {
			return FALSE;
		}
	}
	else {
		/* EFCg[hFALSE */
		bmc_wait = FALSE;
	}

	/* Cxg */
	if (bmc_wait) {
		schedule_handle(EVENT_BMC_L, bmc32_drq_event);
		schedule_handle(EVENT_BMC128_L, bmc128_drq_event);
	}
	else {
		schedule_handle(EVENT_BMC_L, bmc32_lost_event);
		schedule_handle(EVENT_BMC128_L, bmc128_lost_event);
	}
	schedule_handle(EVENT_BMC_M, bmc32_multi_event);
	schedule_handle(EVENT_BMC128_M, bmc128_multi_event);

	return TRUE;
}

#endif	/* XM7_VER == 1 && defined(BUBBLE) */
