/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ fBXvC ]
 */

#include <stdlib.h>
#include <string.h>
#include "xm7.h"
#include "display.h"
#include "subctrl.h"
#include "device.h"
#include "ttlpalet.h"
#include "multipag.h"
#include "mainetc.h"
#include "aluline.h"
#include "keyboard.h"
#include "kanji.h"
#include "event.h"

/*
 *	O[o [N
 */
BOOL crt_flag;							/* CRT ONtO */
BOOL vrama_flag;						/* VRAMANZXtO */
WORD vram_offset[2];					/* VRAMItZbgWX^ */
WORD crtc_offset[2];					/* CRTCItZbg */
BOOL vram_offset_flag;					/* gVRAMItZbgWX^tO */
BOOL vsync_flag;						/* VSYNCtO */
BOOL draw_aftervsync;					/* ʕ`ʒm^C~O */
int now_raster;							/* ݃X^ʒu */
BOOL magus_patch;						/* MAGUS΍􏈗tO */

BOOL blank_flag;						/* uLOtO */
#if XM7_VER >= 2
BOOL subnmi_flag;						/* TuNMICl[utO */

BYTE vram_active;						/* ANeBuy[W */
BYTE *vram_aptr;						/* VRAMANeBv|C^ */
BYTE vram_display;						/* \y[W */
BYTE *vram_dptr;						/* VRAM\|C^ */
#endif


#if XM7_VER >= 3
/* FM77AV40 */
BYTE screen_mode;						/* ʃ[h */
BYTE subram_vrambank;					/* ANeBuy[W(400line/26F) */
BOOL sub_kanji_bank;					/* ROMI */

/* FM77AV40EX */
WORD window_x1, window_dx1;				/* EBhE X1 */
WORD window_y1, window_dy1;				/* EBhE Y1 */
WORD window_x2, window_dx2;				/* EBhE X2 */
WORD window_y2, window_dy2;				/* EBhE Y2 */
BOOL window_open;						/* EChEI[vtO */

BYTE block_active;						/* ANeBuubN */
BYTE *vram_ablk;						/* ANeBuubN|C^ */
BYTE block_display;						/* \ubN */
BYTE *vram_bdptr;						/* \ubN|C^ */
BYTE *vram_dblk;						/* \ubN|C^2 */
BYTE *vram_bdblk;						/* \ubN|C^2 */
#endif

#if XM7_VER == 1 && defined(L4CARD)
BOOL width40_flag;						/* width flag */
BOOL cursor_lsb;						/* J[\AhXLSB */
BOOL enable_400line;					/* 400C[htO */
BOOL workram_select;					/* [NRAMZNgtO */

BYTE crtc_register[0x20];				/* CRTCWX^ */
BYTE crtc_regnum;						/* CRTCWX^ԍWX^ */

WORD text_start_addr;					/* eLXgX^[gAhX */
WORD cursor_addr;						/* J[\AhX */
BOOL text_blink;						/* eLXguN */
BOOL cursor_blink;						/* J[\uN */
#endif

/*
 *	X^eBbN [N
 */
static BYTE *vram_buf;					/* VRAMXN[obt@ */
static BYTE vram_offset_count[2];		/* VRAMItZbgݒJE^ */
static WORD hdisp_count;				/* HDISPJE^ */
#if XM7_VER == 1 && defined(L4CARD)
static DWORD text_scroll_count;			/* TVRAMItZbgݒJE^ */
static DWORD text_cursor_count;			/* TVRAMJ[\ʒuݒJE^ */
static BYTE text_blink_count;			/* eLXguNJE^ */
static BYTE cursor_blink_count;			/* J[\uNJE^ */
#endif

/*
 *	vg^Cv錾
 */
static BOOL FASTCALL subcpu_event(void); /* TuCPU^C}Cxg */
static BOOL FASTCALL display_vsync(void);/* VSYNCCxg */
static BOOL FASTCALL display_hblank(void);/* HBLANKCxg */
static void FASTCALL display_vblank(void);/* VBLANKCxg */
static void FASTCALL vram_scroll(WORD offset);/* VRAMXN[ */
#if XM7_VER == 1 && defined(L4CARD)
static BOOL FASTCALL display_text_blink(void);/* eLXguNCxg */
static BOOL FASTCALL display_cursor_blink(void);/* J[\uNCxg */
#endif

#if (XM7_VER >= 3) && (defined(_OMF) || defined(_WIN32) || defined(FMT))
extern void memcpy400l(BYTE *, BYTE *, int);
										/* 400CXN[p] */
#endif

/*
 *	24/32bit Colorp26F[hPxe[u
 */
#if XM7_VER >= 3
const BYTE truecolorbrightness[64] = {
	  0,	  4,	  8,	 12,	 16,	 20,	 24,	 28,
	 32,	 36,	 40,	 45,	 49,	 53,	 57,	 61,
	 65,	 69,	 73,	 77,	 81,	 85,	 89,	 93,
	 97,	101,	105,	109,	113,	117,	121,	125,
	130,	134,	138,	142,	146,	150,	154,	158,
	162,	166,	170,	174,	178,	182,	186,	190,
	194,	198,	202,	206,	210,	215,	219,	223,
	227,	231,	235,	239,	243,	247,	251,	255,
};
#endif

/*
 *	fMԃe[u
 */
#define	VBLANK	(pdisp->vfp + pdisp->vsync + pdisp->vbp)
#define	HBLANK	(pdisp->hblank)
typedef struct {
//	DWORD vblank;						/* uLO */
	DWORD vfp;							/* tg|[` */
	DWORD vsync;						/*  */
	DWORD vbp;							/* obN|[` */
	DWORD vdisp;						/* \ */
	DWORD hblank;						/* uLO */
//	DWORD hfp;							/* tg|[` */
//	DWORD hsync;						/*  */
//	DWORD hbp;							/* obN|[` */
	DWORD hdisp;						/* \ */
	WORD nline;							/* C */
} display_t;
#if (XM7_VER >= 3) || (XM7_VER == 1 && defined(L4CARD))
static const display_t disp[] = {
	{
		/* 200C(15kHz)[h */
//		(1520 + 510 + 1910),			/* uLO */
		1520,							/* tg|[` 1.52ms */
		510,							/*  0.51ms */
		1910,							/* obN|[` 1.91ms */
		12700,							/* \ 12.7ms */
		24,								/* uLO 23.8s */
//		?.								/* tg|[` ?s */
//		?.								/*  ?s */
//		?.								/* obN|[` ?s */
		39,								/* \ 39.7s */
		200,							/* 200C */
	},
	{
		/* 400C(24kHz)[h */
//		(1520 + 510 + 1910),			/* uLO */
		340,							/* tg|[` 0.34ms */
		330,							/*  0.33ms */
		980,							/* obN|[` 0.98ms */
		16400,							/* \ 16.4ms */
		11,								/* uLO 11s */
//		?.								/* tg|[` ?s */
//		?.								/*  ?s */
//		?.								/* obN|[` ?s */
		30,								/* \ 30s */
		400,							/* 400C */
	},
}, *pdisp;
#else
static const display_t disp = {
	/* 200C(15kHz)[h */
//	(1520 + 510 + 1910),				/* uLO */
	1520,								/* tg|[` 1.52ms */
	510,								/*  0.51ms */
	1910,								/* obN|[` 1.91ms */
	12700,								/* \ 12.7ms */
	24,									/* uLO 23.8s */
//	?.									/* tg|[` ?s */
//	?.									/*  ?s */
//	?.									/* obN|[` ?s */
	39,									/* \ 39.7s */
	200,								/* 200C */
}, * const pdisp = &disp;
#endif

/*
 *	ID
 */
#define	ID	MAKEID('D', 'I', 'S', 'P')
//#define DISPLAY_LOG

/*
 *	fBXvC
 *	
 */
BOOL FASTCALL display_init(void)
{
	/* VRAMXN[pobt@m */
#if XM7_VER >= 3 || (XM7_VER == 1 && defined(L4CARD))
	vram_buf = (BYTE *)malloc(0x8000);
#else
	vram_buf = (BYTE *)malloc(0x4000);
#endif
	if (vram_buf == NULL) {
		return FALSE;
	}

#if XM7_VER == 1 && defined(L4CARD)
	/* 200C[hɐݒ */
	enable_400line = FALSE;
#endif

	/* `ʒm^C~OVSYNC */
	draw_aftervsync = TRUE;

	/* MAGUSpb`͗L */
	magus_patch = TRUE;

	/* CRTCItZbg[NNA */
	memset(crtc_offset, 0, sizeof(crtc_offset));

	return TRUE;
}

/*
 *	fBXvC
 *	N[Abv
 */
void FASTCALL display_cleanup(void)
{
#if 0
	ASSERT(vram_buf);
#endif
	if (vram_buf) {
		free(vram_buf);
	}
}

/*
 *	fBXvC
 *	Zbg
 */
void FASTCALL display_reset(void)
{
#if XM7_VER >= 2
	int i;
#endif

	LOG0(Normal, "Zbg");

	/* Zbg̃XN[ʒu␳ */
#if XM7_VER >= 2
	for (i=0; i<2; i++) {
		vram_scroll((WORD)-crtc_offset[i]);
	}
#else
	vram_scroll((WORD)-crtc_offset[0]);
#endif

	/* CRTWX^ */
	crt_flag = FALSE;
	vrama_flag = FALSE;
	memset(vram_offset, 0, sizeof(vram_offset));
	memset(crtc_offset, 0, sizeof(crtc_offset));
	vram_offset_flag = FALSE;
	memset(vram_offset_count, 0, sizeof(vram_offset_count));
	now_raster = 0;

	/* 荞݁ACxg */
	vsync_flag = FALSE;
	blank_flag = TRUE;
#if XM7_VER >= 2
	subnmi_flag = TRUE;

	/* ANeBuy[WA\y[W */
	vram_active = 0;
	vram_aptr = vram_c;
	vram_display = 0;
	vram_dptr = vram_c;
#if XM7_VER >= 3
	subram_vrambank = 0;

	/* n[hEFAEBhE */
	window_x1 = window_x2 = 0;
	window_y1 = window_y2 = 0;
	window_dx1 = window_dx2 = 0;
	window_dy1 = window_dy2 = 0;
	window_open = FALSE;

	/* ANeBuubNA\ubN */
	block_active = 0;
	block_display = 0;
	vram_ablk = vram_c;
	vram_dblk = vram_c;
	vram_bdptr = vram_c + 0x18000;
	vram_bdblk = vram_bdptr;

	/* TuROM */
	sub_kanji_bank = FALSE;
#endif	/* XM7_VER >= 3 */
#elif defined(L4CARD)
	/* TextVRAM */
	text_cursor_count = 0;
	text_scroll_count = 0;
	text_start_addr = 0x0000;
	text_blink = TRUE;
	cursor_addr = 0x0000;
	cursor_blink = TRUE;
	text_blink_count = 0;
	cursor_blink_count = 0;
	workram_select = FALSE;

	/* CRTC */
	crtc_regnum = 0;
	memset(crtc_register, 0, sizeof(crtc_register));

	/* 400C[h̓eLXguNCxgǉ */
	if (enable_400line && enable_400linecard) {
		schedule_setevent(EVENT_TEXT_BLINK, 160*1000, display_text_blink);
	}
	else {
		schedule_delevent(EVENT_TEXT_BLINK);
	}
#endif

	/* 20msƂɋNCxgǉ */
	schedule_setevent(EVENT_SUBTIMER, 20000, subcpu_event);

	/* uLO */
	display_vblank();
}

#if XM7_VER == 1 && defined(L4CARD)
/*
 *	eLXguNCxg
 */
static BOOL FASTCALL display_text_blink(void)
{
	WORD addr;
	WORD ofsaddr;

	/* 400C[hłȂ΃Cxg폜ċA */
	if (!(enable_400line && enable_400linecard)) {
		schedule_delevent(EVENT_TEXT_BLINK);
		return TRUE;
	}

	/* eLXguN (320ms) */
	if (text_blink_count ++ >= 2) {
		/* uNԂ𔽓] */
		text_blink = (!text_blink);

		/* uNLN^ */
		for (addr = 0; addr < 4000; addr += (WORD)2) {
			ofsaddr = (WORD)((addr + text_start_addr) & 0xFFE);
			if (tvram_c[ofsaddr + 1] & 0x10) {
				tvram_notify(ofsaddr, 0);
			}
		}

		/* JE^Zbg */
		text_blink_count = 0;
	}

	/* J[\uN (320/160ms) */
	if (crtc_register[10] & 0x40) {
		cursor_blink_count++;
		if ((cursor_blink_count >= 2) || !(crtc_register[10] & 0x20)) {
			/* uNԂ𔽓] */
			cursor_blink = (!cursor_blink);

			/* J[\ʒuĕ\ */
			tvram_notify(cursor_addr, 0);

			/* JE^Zbg */
			cursor_blink_count = 0;
		}
	}

	return TRUE;
}
#endif

/*
 *	VSYNCCxg ()
 */
static BOOL FASTCALL display_vsync(void)
{
#ifdef DISPLAY_LOG
	LOG4(Normal, LGFMT "vsync_flag:%d blank_flag:%d hdisp_count:%d",
				 LGARG, vsync_flag, blank_flag, hdisp_count);
#endif
	if (!vsync_flag) {
		if (/*(hdisp_count >= pdisp->nline) && */(!blank_flag)) {
			/* ꏄ ꂩ琂tg|[` */
			/*          1.52ms(15kHz) / 0.34ms(24kHz) */
			display_vblank();
			return TRUE;
		}

		/* ꂩ琂 0.51ms(15kHz) / 0.33ms(24kHz) */
		vsync_flag = TRUE;
		schedule_setevent(EVENT_VSYNC, pdisp->vsync, display_vsync);

#if XM7_VER >= 2
		/* rfIfBW^CY */
		if (digitize_enable) {
			if (digitize_keywait || simpose_mode == 0x03) {
				digitize_notify();
			}
		}
#endif
	}
	else {
		/* ꂩ琂obN|[`+\  */
		/* 1.91ms+12.7ms(15kHz) / 0.98ms+16.4ms(24kHz) */
		now_raster = 0;
		vblankperiod_notify();
		vsync_flag = FALSE;
		schedule_setevent(EVENT_VSYNC,
			pdisp->vbp + pdisp->vdisp, display_vsync);

		/* VSYNCʒm */
		if (draw_aftervsync) {
			vsync_notify();
		}
	}

	return TRUE;
}

/*
 *	HBLANKCxg (A)
 */
static BOOL FASTCALL display_hblank(void)
{
#ifdef DISPLAY_LOG
	LOG4(Normal, LGFMT "vsync_flag:%d blank_flag:%d hdisp_count:%d",
				 LGARG, vsync_flag, blank_flag, hdisp_count);
#endif
	if (hdisp_count >= pdisp->nline) {
		if (!blank_flag) {
			/* ꏄ ꂩ uLO */
			/*      3.94ms(15kHz) / 1.65ms(24kHz) */
			/*  display_vsyncŏu邽߂ւ͂Ȃ */
			/* display_vblank(); */
			/* return TRUE; */
		}
		else {
			/* ꂩ0CڐuLO */
			/*       24s(15kHz) / 11s(24kHz) */
			schedule_setevent(EVENT_BLANK, HBLANK, display_hblank);
			hdisp_count = 0;
			return TRUE;
		}
	}

	if (blank_flag) {
		/* ꂩ琅\ 39s40s(15kHz) / 30s(24kHz) */
		blank_flag = FALSE;
#if (XM7_VER >= 3) || (XM7_VER == 1 && defined(L4CARD))
		if (pdisp->hdisp == 30) {
			schedule_setevent(EVENT_BLANK, pdisp->hdisp, display_hblank);
		}
		else {
			schedule_setevent(EVENT_BLANK,
				pdisp->hdisp + (hdisp_count & 1), display_hblank);
		}
#else
		schedule_setevent(EVENT_BLANK,
			pdisp->hdisp + (hdisp_count & 1), display_hblank);
#endif
		hdisp_count++;
		return TRUE;
	}
	else {
		/* ꂩ琅uLO 24s(15kHz) / 11s(24kHz) */
		hblank_notify();
		now_raster ++;
		blank_flag = TRUE;
		schedule_setevent(EVENT_BLANK, HBLANK, display_hblank);
		return TRUE;
	}
}

/*
 *	VBLANKCxg (A)
 */
static void FASTCALL display_vblank(void)
{
#ifdef DISPLAY_LOG
	LOG4(Normal, LGFMT "vsync_flag:%d blank_flag:%d hdisp_count:%d",
				 LGARG, vsync_flag, blank_flag, hdisp_count);
#endif
#if (XM7_VER >= 3) || (XM7_VER == 1 && defined(L4CARD))
	/* 200C,400Cɂ߂ */
#if XM7_VER >= 3
	if (screen_mode == SCR_400LINE) {
#else
	if (enable_400line && enable_400linecard) {
#endif
		/* 24kHz */
		pdisp = &disp[1];
	}
	else {
		/* 15kHz */
		pdisp = &disp[0];
	}
#endif
	hdisp_count = pdisp->nline;
	vsync_flag = FALSE;
	blank_flag = TRUE;

	/* ꂩ琂tg|[` 1.52ms(15kHz) / 0.34ms(24kHz) */
	schedule_setevent(EVENT_VSYNC, pdisp->vfp, display_vsync);

	/* ꂩ琂tg|[`++obN|[` */
	/* 1.52ms+0.51ms+1.91ms(15kHz) / 0.34ms+0.33ms+0.98ms(24kHz)    */
	schedule_setevent(EVENT_BLANK, VBLANK, display_hblank);

	/* VSYNCʒm */
	if (!draw_aftervsync) {
		vsync_notify();
	}
}

/*
 *	TuCPU
 *	Cxg
 */
static BOOL FASTCALL subcpu_event(void)
{
#if XM7_VER >= 2
	/* Ô߁A`FbN */
	if (!subnmi_flag && (model_type >= MODEL_FM77AV)) {
		return FALSE;
	}
#endif

	/* NMI荞݂N */
	subcpu_nmi();
	return TRUE;
}

/*
 *	|C^Đݒ
 */
void FASTCALL display_setpointer(BOOL redraw)
{
#if XM7_VER >= 3
	/* ʃ[hԍ */
	if (mode400l) {
		screen_mode = SCR_400LINE;
	}
	else if (mode256k) {
		screen_mode = SCR_262144;
	}
	else if (mode320) {
		screen_mode = SCR_4096;
	}
	else {
		screen_mode = SCR_200LINE;
	}
#endif

#if XM7_VER >= 2
	/* ANeBu|C^EANeBuubN|C^ */
	vram_aptr = vram_c;
#if XM7_VER >= 3
	vram_ablk = vram_c;
	switch (screen_mode) {
		case SCR_400LINE	:	/* 640x400 8F */
								vram_aptr += (subram_vrambank * 0x8000);
								if (block_active) {
									vram_aptr += 0x18000;
									vram_ablk += 0x18000;
								}
								break;
		case SCR_262144		:	/* 320x200 262144F */
								switch (subram_vrambank) {
									case	0	: break;
									case	1	: vram_aptr += 0x4000;
												  break;
									case	2	: vram_aptr += 0x18000;
												  break;
								}
								break;
		default				:	/* 640x200A320x200 4096F */
								if (vram_active) {
									vram_aptr += 0x4000;
								}
								if (block_active) {
									vram_aptr += 0x18000;
								}
	}
#else
	if (vram_active) {
		vram_aptr += 0xc000;
	}
#endif

	/* \|C^A\ubN|C^ */
	vram_dptr = vram_c;
#if XM7_VER >= 3
	vram_dblk = vram_c;
	vram_bdblk = vram_c;
	if ((screen_mode == SCR_200LINE) && vram_display) {
		vram_dptr += 0x4000;
	}
	vram_bdptr = vram_dptr;
	if (block_display) {
		vram_dptr += 0x18000;
		vram_dblk += 0x18000;
	}
	else {
		vram_bdptr += 0x18000;
		vram_bdblk += 0x18000;
	}
#else
	if (!mode320 && vram_display) {
		vram_dptr += 0xc000;
	}
#endif	/* XM7_VER >= 3 */
#endif	/* XM7_VER >= 2 */

	/* KvȂĕ` */
	if (redraw) {
		display_notify();
	}
}

/*
 *	n[hEFAEChE
 *	I[v`FbNE͈͌
 */
#if XM7_VER >= 3
static void FASTCALL check_window_open(void)
{
	/* Xs<Xe and Ys<Ye ł΁AEBhEI[v */
	if ((window_x1 < window_x2) && (window_y1 < window_y2)) {
		window_open = TRUE;
	}
	else {
		window_open = FALSE;
		window_dx1 = 0;
		window_dx2 = 0;
		window_dy1 = 0;
		window_dy2 = 0;
	}

	/* ĕ`w */
	window_notify();
}

/*
 *	n[hEFAEChE
 *	NbsO
 */
void FASTCALL window_clip(int mode)
{
	static const WORD max_x[4] = { 640, 320, 640, 320 };
	static const WORD max_y[4] = { 200, 200, 400, 200 };

	ASSERT((mode >= 0) && (mode <= 2));

	/* XNbsO */
	window_dx1 = window_x1;
	window_dx2 = window_x2;
	if (window_dx1 > max_x[mode]) {
		window_dx1 = max_x[mode];
	}
	if (window_dx2 > max_x[mode]) {
		window_dx2 = max_x[mode];
	}

	/* YNbsO */
	window_dy1 = window_y1;
	window_dy2 = window_y2;
	if (window_dy1 > max_y[mode]) {
		window_dy1 = max_y[mode];
	}
	if (window_dy2 > max_y[mode]) {
		window_dy2 = max_y[mode];
	}
}
#endif

/*
 *	4096F/262144F[hp VRAMXN[
 */
#if XM7_VER >= 2
static void FASTCALL vram_scroll_analog(WORD offset, DWORD addr)
{
	int i;
	BYTE *vram;

#if XM7_VER >= 3
	for (i=0; i<3; i++) {
		vram = (BYTE *)((vram_c + addr) + 0x8000 * i);

		/* e|obt@փRs[ */
		memcpy(vram_buf, vram, offset);
		memcpy(&vram_buf[0x2000], &vram[0x2000], offset);

		/* O֋l߂ */
		memcpy(vram, (vram + offset), 0x4000 - offset);

		/* e|obt@蕜 */
		memcpy(vram + (0x2000 - offset), vram_buf, offset);
		memcpy(vram + (0x4000 - offset), &vram_buf[0x2000], offset);
	}
#else
	for (i=0; i<6; i++) {
		vram = (BYTE *)((vram_c + addr) + 0x2000 * i);

		/* e|obt@փRs[ */
		memcpy(vram_buf, vram, offset);

		/* O֋l߂ */
		memcpy(vram, (vram + offset), 0x2000 - offset);

		/* e|obt@蕜 */
		memcpy(vram + (0x2000 - offset), vram_buf, offset);
	}
#endif
}
#endif

/*
 *	400C[hVRAMXN[p] (C)
 */
#if (XM7_VER >= 3) && (!(defined(_OMF) || defined(_WIN32) || defined(FMT)))
static void FASTCALL memcpy400l(BYTE *dest, BYTE *src, WORD siz)
{
	siz >>= 1;
	while (siz) {
		*dest = *src;
		src += 2;
		dest += 2;
		siz --;
	}
}
#endif

/*
 *	VRAMXN[
 */
static void FASTCALL vram_scroll(WORD offset)
{
	int i;
	BYTE *vram;

	if (offset == 0) {
		return;
	}

#if XM7_VER >= 2
#if XM7_VER >= 3
	/* 400C */
	if (screen_mode == SCR_400LINE) {
		/* 400C ItZbg}XN */
		offset &= 0x3fff;
		offset <<= 1;

		/* [v */
		for (i=0; i<3; i++) {
			vram = (BYTE *)(vram_c + 0x8000 * i + vram_active);

			/* e|obt@փRs[ */
			memcpy400l(vram_buf, vram, offset);

			/* O֋l߂ */
			memcpy400l(vram, (vram + offset), 0x8000 - offset);

			/* e|obt@蕜 */
			memcpy400l(vram + (0x8000 - offset), vram_buf, offset);
		}
		return;
	}
#endif

	/* 4096F/262144F */
	if (SCR_MODE_ANALOG) {
		/* 320 ItZbg}XN */
		offset &= 0x1fff;

		if (vram_active == 1) {
			/* oN1 */
#if XM7_VER >= 3
			vram_scroll_analog(offset, 0x04000);
#else
			vram_scroll_analog(offset, 0x0c000);
#endif
		}
		else {
			/* oN0 */
			vram_scroll_analog(offset, 0x00000);
#if XM7_VER >= 3
			if (screen_mode == SCR_262144) {
				/* 26F[h̓oN2ɃXN[ */
				vram_scroll_analog(offset, 0x18000);
			}
#endif
		}

		return;
	}
#endif	/* XM7_VER >= 2 */

#if XM7_VER == 1 && defined(L4CARD)
	if (enable_400line && enable_400linecard) {
		/* 400CPF̓_ŃXN[s */
		/* (C$FD37̋Č̊֌W) */
		return;
	}
#endif

	/* 8F */
	offset &= 0x3fff;

	/* [v */
	for (i=0; i<3; i++) {
#if XM7_VER >= 3
		vram = (BYTE *)(vram_c + 0x8000 * i);
		if (vram_active) {
			vram += 0x4000;
		}
#elif XM7_VER >= 2
		vram = (BYTE *)(vram_c + 0x4000 * i);
		if (vram_active) {
			vram += 0xc000;
		}
#else
		vram = (BYTE *)(vram_c + 0x4000 * i);
#endif

		/* e|obt@փRs[ */
		memcpy(vram_buf, vram, offset);

		/* O֋l߂ */
		memcpy(vram, (vram + offset), 0x4000 - offset);

		/* e|obt@蕜 */
		memcpy(vram + (0x4000 - offset), vram_buf, offset);
	}
}

/*
 *	400C[hpVRAMzu␳
 */
#if XM7_VER >= 3
BOOL FASTCALL fix_vram_address(void)
{
	DWORD	i;

	for (i=0; i<0x30000; i+=0x18000) {
		memcpy(&vram_buf[0x00000], &vram_c[0x04000 + i], 0x4000);
		memcpy(&vram_buf[0x04000], &vram_c[0x10000 + i], 0x4000);
		memcpy(&vram_c[0x04000 + i], &vram_c[0x08000 + i], 0x4000);
		memcpy(&vram_c[0x10000 + i], &vram_c[0x0c000 + i], 0x4000);
		memcpy(&vram_c[0x08000 + i], &vram_buf[0x04000], 0x4000);
		memcpy(&vram_c[0x0c000 + i], &vram_buf[0x00000], 0x4000);
	}

	return TRUE;
}
#endif

#if XM7_VER == 1 && defined(L4CARD)
/*
 *	J[\ ʒuEuNxĐݒ
 */
void FASTCALL cursor_setup(void)
{
	WORD cursor_addr_old;

	/* J[\ړ */
	cursor_addr_old = cursor_addr;
	cursor_addr  = (WORD)(crtc_register[14] << 10);
	cursor_addr |= (WORD)(crtc_register[15] << 2);
	if (cursor_lsb) {
		cursor_addr += (WORD)2;
	}
	cursor_addr &= (WORD)0xFFF;

	/* J[\WƐVJ[\Wꂼĕ` */
	tvram_notify(cursor_addr_old, 0);
	tvram_notify(cursor_addr, 0);
}

/*
 *	CRTC(HD6845) PoCgǂݍ
 */
static BYTE FASTCALL crtc_readb(BYTE reg)
{
	if ((reg >= 0x0c) && (reg <= 0x11)) {
		/* 0x0c`0x11͋LĂlԂ */
		return crtc_register[reg];
	}
	else {
		/* 0x0c`0x11ȊO̓CgI[ */
		return 0xff;
	}
}

/*
 *	CRTC(HD6845) PoCg
 */
static void FASTCALL crtc_writeb(BYTE reg, BYTE dat)
{
	/* 񂾒lۑ */
	crtc_register[reg] = dat;

	switch (reg) {
		/* J[\TCY */
		case 0x0a :
		case 0x0b :
			cursor_setup();
			break;

		/* eLXgX^[gAhX() */
		case 0x0c :
			text_start_addr &= 0x03FC;
			text_start_addr |= (WORD)((dat & 0x03) << 10);
			text_scroll_count ++;
			if ((text_scroll_count & 1) == 0) {
				tvram_redraw_notify();
			}
			break;

		/* eLXgX^[gAhX() */
		case 0x0d :
			text_start_addr &= 0xFC00;
			text_start_addr |= (WORD)(dat << 2);
			text_scroll_count ++;
			if ((text_scroll_count & 1) == 0) {
				tvram_redraw_notify();
			}
			break;

		/* J[\AhX */
		case 0x0e :
		case 0x0f :
			text_cursor_count ++;
			if ((text_cursor_count & 1) == 0) {
				cursor_setup();
			}
			break;
	}
}
#endif

/*
 *	fBXvC
 *	PoCgǂݍ
 *	C|TuC^tF[XM܂
 */
BOOL FASTCALL display_readb(WORD addr, BYTE *dat)
{
	BYTE ret;
#if XM7_VER >= 3 || (XM7_VER == 1 && defined(L4CARD))
	int offset;
#endif	/* XM7_VER >= 3 */

	switch (addr) {
		/* LZIRQ ACK */
		case 0xd402:
			subcancel_flag = FALSE;
			subcancel_request = FALSE;
			subcpu_irq();
			*dat = 0xff;
			return TRUE;

		/* BEEP */
		case 0xd403:
			beep_flag = TRUE;
			*dat = 0xff;
			schedule_setevent(EVENT_BEEP, 205000, mainetc_beep);

			/* ʒm */
			beep_notify();
			return TRUE;

		/* AeVIRQ ON */
		case 0xd404:
			subattn_flag = TRUE;
			*dat = 0xff;
			maincpu_firq();
			return TRUE;

#if XM7_VER == 1
		/* Tu[hWX^ */
		case 0xd405:
			/* FM-77[ĥݗL */
			if (model_type != MODEL_FM77) {
				return FALSE;
			}

			ret = 0xff;

#ifdef L4CARD
			/* bit7`1400CJ[ĥݗL */
			if (enable_400linecard) {
				/* uLO */
				if (blank_flag) {
					ret &= (BYTE)~0x80;
				}

				/* VSYNC */
				if (!vsync_flag) {
					ret &= (BYTE)~0x40;
				}

				/* C */
				if (select_400line) {
					ret &= ~0x20;
				}

				/* CURSOR LSB */
				if (!cursor_lsb) {
					ret &= (BYTE)~0x10;
				}

				/* WIDTH */
				if (width40_flag) {
					ret &= (BYTE)~0x08;
				}

				/* [NRAMI */
				if (!workram_select) {
					ret &= (BYTE)~0x04;
				}

				/* 400C[h */
				if (enable_400line) {
					ret &= ~0x02;
				}
			}
#endif

			/* TCNX`[ */
			if (cycle_steal) {
				ret &= ~0x01;
			}

			*dat = ret;
			return TRUE;
#endif

#if XM7_VER >= 3 || (XM7_VER == 1 && defined(L4CARD))
		/* TuROM */
		case 0xd406:		/* TuLEFT */
		case 0xd407:		/* TuRIGHT */
#if XM7_VER >= 3
			/* FM77AV40/FM77AV40EX̂ݗL */
			if (model_type < MODEL_FM77AV40) {
#else
			/* FM-77[ĥݗL */
			if (model_type != MODEL_FM77) {
#endif
				return FALSE;
			}

			if (subkanji_flag) {
				/* AhX̓[hPʂŁA8bit̂ݎ擾 */
				offset = kanji_addr << 1;
#if XM7_VER >= 3
				if (sub_kanji_bank) {
					*dat = kanji_rom2[offset + (addr & 1)];
				}
				else {
					*dat = kanji_rom[offset + (addr & 1)];
				}
#else
				/* ʏ̈ */
				*dat = kanji_rom[offset + (addr & 1)];
#endif
			}
			else {
				LOG1(Warning, "`oCgǂݍ $%04X", addr);
				*dat = 0xff;
			}
			return TRUE;
#endif

		/* CRT ON */
		case 0xd408:
			if (!crt_flag) {
				crt_flag = TRUE;
				/* CRT OFFON */
				display_notify();
			}
			*dat = 0xff;
			return TRUE;

		/* VRAMANZX ON */
		case 0xd409:
			vrama_flag = TRUE;
			*dat = 0xff;
			return TRUE;

		/* BUSYtO OFF */
		case 0xd40a:
			subbusy_flag = FALSE;
			*dat = 0xff;
			return TRUE;

#if XM7_VER == 1 && defined(L4CARD)
		/* CRTCAhXWX^(400LINE CARD) */
		case 0xd40b:
			/* FM-77[ĥݗL */
			if (model_type != MODEL_FM77) {
				return FALSE;
			}

			if (enable_400linecard) {
				*dat = (BYTE)(crtc_regnum & 0x1f);
			}
			else {
				LOG1(Warning, "`oCgǂݍ $%04X", addr);
				*dat = 0xff;
			}
			return TRUE;

		/* CRTCf[^WX^(400LINE CARD) */
		case 0xd40c:
			/* FM-77[ĥݗL */
			if (model_type != MODEL_FM77) {
				return FALSE;
			}

			if (enable_400linecard) {
				*dat = (BYTE)crtc_readb(crtc_regnum);
			}
			else {
				LOG1(Warning, "`oCgǂݍ $%04X", addr);
				*dat = 0xff;
			}
			return TRUE;
#endif

#if XM7_VER >= 3
		/* FM77AV40 TuRAMoNZNg/TuROMZNg */
		case 0xd42e:
			/* ǂݏooȂ */
			LOG1(Warning, "`oCgǂݍ $%04X", addr);
			*dat = 0xff;
			return TRUE;

		/* FM77AV40 400C/26FpVRAMoNZNg */
		case 0xd42f:
			/* FM77AV40/FM77AV40EX̂ݗL */
			if (model_type >= MODEL_FM77AV40) {
				*dat = (BYTE)(0xfc | (subram_vrambank & 3));
			}
			else {
				LOG1(Warning, "`oCgǂݍ $%04X", addr);
				*dat = 0xff;
			}
			return TRUE;
#endif

#if XM7_VER >= 2
		/* FM77AV MISCWX^ */
		case 0xd430:
			/* FM77AVȍ~ŗL */
			if (model_type >= MODEL_FM77AV) {
				ret = 0xff;

				/* uLO */
				if (blank_flag) {
					ret &= (BYTE)~0x80;
				}

				/*  */
				if (line_busy) {
					ret &= (BYTE)~0x10;
					/* LINE BOOST͈񂾂BUSY */
					if (line_boost) {
						line_busy = FALSE;
						schedule_delevent(EVENT_LINE);
					}
				}

				/* VSYNC */
				if (!vsync_flag) {
					ret &= (BYTE)~0x04;
				}

				/* TuRESETXe[^X */
				if (!subreset_flag) {
					ret &= (BYTE)~0x01;
				}

				*dat = ret;
				return TRUE;
			}

			return FALSE;
#endif
	}

	return FALSE;
}

/*
 *	fBXvC
 *	PoCg
 *	C|TuC^tF[XM܂
 */
BOOL FASTCALL display_writeb(WORD addr, BYTE dat)
{
	WORD offset;
#if XM7_VER >= 2
	BOOL redraw_flag;
#endif

	switch (addr) {
#if XM7_VER == 1
		/* Tu[hWX^ */
		case 0xd405:
			/* FM-77[ĥݗL */
			if (model_type != MODEL_FM77) {
				return FALSE;
			}

			/* TCNX`[ */
			if (dat & 0x01) {
				if (cycle_steal) {
					cycle_steal_mode = FALSE;
				}
			}
			else {
				if (!cycle_steal) {
					cycle_steal_mode = TRUE;
				}
			}

#ifdef L4CARD
			/* bit4`1400CJ[hL̂ݗL */
			if (enable_400linecard) {
				/* CURSOR LSB */
				if (dat & 0x10) {
					cursor_lsb = TRUE;
				}
				else {
					cursor_lsb = FALSE;
				}

				/* WIDTH */
				if (dat & 0x08) {
					width40_flag = FALSE;
				}
				else {
					width40_flag = TRUE;
				}

				/* [NRAMI */
				if (dat & 0x04) {
					workram_select = TRUE;
				}
				else {
					workram_select = FALSE;
				}

				/* 400CJ[h [h؂芷 */
				if (dat & 0x02) {
					if (!enable_400line) {
						return TRUE;
					}
					enable_400line = FALSE;
				}
				else {
					if (enable_400line) {
						return TRUE;
					}
					enable_400line = TRUE;
				}

				/* tOރZbg */
				subreset_flag = TRUE;
				subbusy_flag = TRUE;

				/* CRTWX^Zbg */
				display_reset();
				display_notify();

				/* INS LED */
				ins_flag = FALSE;

				/* TuCPUZbg */
				subcpu_reset();
			}
#endif
			return TRUE;
#endif

#if XM7_VER >= 3 || (XM7_VER == 1 && defined(L4CARD))
		/* TuROM AhX */
		/* TuROM AhX */
		case 0xd406:
		case 0xd407:
#if XM7_VER >= 3
			/* FM77AV40/FM77AV40EX̂ݗL */
			if (model_type < MODEL_FM77AV40) {
#else
			/* FM-77[ĥݗL */
			if (model_type != MODEL_FM77) {
#endif
				return FALSE;
			}

			if (addr & 1) {
				kanji_addr &= (WORD)0xff00;
				kanji_addr |= (WORD)dat;
			}
			else {
				kanji_addr &= (WORD)0x00ff;
				kanji_addr |= (WORD)(dat << 8);
			}
			return TRUE;
#endif

		/* CRT OFF */
		case 0xd408:
			if (crt_flag) {
				/* CRT ONOFF */
				crt_flag = FALSE;
				display_notify();
			}
			crt_flag = FALSE;
			return TRUE;

		/* VRAMANZX OFF */
		case 0xd409:
			vrama_flag = FALSE;
			return TRUE;

		/* BUSYtO ON */
		case 0xd40a:
			if (magus_patch) {
				/* CLR߃`FbN */
				if ((fetch_op == 0x0f) ||
					(fetch_op == 0x6f) ||
					(fetch_op == 0x7f)) {
					busy_CLR_count ++;
					if (busy_CLR_count >= 2) {
						subbusy_flag = FALSE;
					}
					else {
						subbusy_flag = TRUE;
					}
				}
				else {
					busy_CLR_count = 0;
					subbusy_flag = TRUE;
				}
			}
			else {
				busy_CLR_count = 0;
				subbusy_flag = TRUE;
			}
			return TRUE;

#if XM7_VER == 1 && defined(L4CARD)
		/* CRTCAhXWX^(400LINE CARD) */
		case 0xd40b:
			/* FM-77[ĥݗL */
			if (model_type != MODEL_FM77) {
				return FALSE;
			}

			if (enable_400linecard) {
				crtc_regnum = (BYTE)(dat & 0x1f);
			}
			else {
				LOG2(Warning, "`oCg $%04X <- $%02X", addr, dat);
			}
			return TRUE;

		/* CRTCf[^WX^(400LINE CARD) */
		case 0xd40c:
			/* FM-77[ĥݗL */
			if (model_type != MODEL_FM77) {
				return FALSE;
			}

			if (enable_400linecard) {
				crtc_writeb(crtc_regnum, dat);
			}
			else {
				LOG2(Warning, "`oCg $%04X <- $%02X", addr, dat);
			}
			return TRUE;
#endif

		/* VRAMItZbgAhX */
		case 0xd40e:
		case 0xd40f:
			if (addr == 0xd40e) {
				/* VRAMItZbgAhX  */
#if XM7_VER == 1 && defined(L4CARD)
				/* ʃ[hɂėLrbgω */
				if (enable_400line && enable_400linecard) {
					offset = (WORD)(dat & 0x7f);
				}
				else {
					offset = (WORD)(dat & 0x3f);
				}
#else
				offset = (WORD)(dat & 0x3f);
#endif
				offset <<= 8;
#if XM7_VER >= 2
				offset |= (WORD)(vram_offset[vram_active] & 0xff);
#else
				offset |= (WORD)(vram_offset[0] & 0xff);
#endif
			}
			else {
				/* VRAMItZbgAhX  */
#if XM7_VER >= 2
				/* gItZbgtOOFFȂA5bit͖ */
				if (!vram_offset_flag) {
					dat &= 0xe0;
				}
				offset = (WORD)(vram_offset[vram_active] & 0x3f00);
				offset |= (WORD)dat;
#else
#if XM7_VER == 1 && defined(L4CARD)
				/* ʃ[hɂėLrbgω */
				if (enable_400line && enable_400linecard) {
					offset = (WORD)(vram_offset[0] & 0x7f00);
					offset |= (WORD)(dat & 0xfe);
				}
				else {
					offset = (WORD)(vram_offset[0] & 0x3f00);
					offset |= (WORD)(dat & 0xe0);
				}
#else
				offset = (WORD)(vram_offset[0] & 0x3f00);
				offset |= (WORD)(dat & 0xe0);
#endif
#endif
			}

#if XM7_VER >= 2
			vram_offset[vram_active] = offset;
			/* JEgAbvAXN[ */
			vram_offset_count[vram_active]++;
			if ((vram_offset_count[vram_active] & 1) == 0) {
				vram_scroll((WORD)(vram_offset[vram_active] -
									crtc_offset[vram_active]));
				crtc_offset[vram_active] = vram_offset[vram_active];
				display_notify();
			}
#else
			vram_offset[0] = offset;
			/* JEgAbvAXN[ */
			vram_offset_count[0]++;
			if ((vram_offset_count[0] & 1) == 0) {
				vram_scroll((WORD)(vram_offset[0] - crtc_offset[0]));
				crtc_offset[0] = vram_offset[0];
				display_notify();
			}
#endif
			return TRUE;

#if XM7_VER >= 3
		/* FM77AV40 TuRAMoNZNg/TuROMZNg */
		case 0xd42e:
			/* FM77AV40/FM77AV40EX̂ݗL */
			if (model_type >= MODEL_FM77AV40) {
				/* bit0-2:CGRAMoNZNg */
				cgram_bank = (BYTE)(dat & 0x07);

				/* bit3,4:R\[RAMoNZNg */
				consram_bank = (BYTE)((dat >> 3) & 0x03);
				if (consram_bank == 3) {
					/* oN3݂͑Ȃ */
					ASSERT(FALSE);
					LOG1(Warning, "m̃R\[RAMoNw(%d)", consram_bank);
					consram_bank = 0;
				}

				/* bit7:1E2ZNg */
				if (dat & 0x80) {
					/* 2 */
					sub_kanji_bank = TRUE;
				}
				else {
					/* 1 */
					sub_kanji_bank = FALSE;
				}
			}
			else {
				LOG2(Warning, "`oCg $%04X <- $%02X", addr, dat);
			}
			return TRUE;

		/* FM77AV40 400C/26FpVRAMoNZNg */
		case 0xd42f:
			/* FM77AV40/FM77AV40EX̂ݗL */
			if (model_type >= MODEL_FM77AV40) {
				subram_vrambank = (BYTE)(dat & 0x03);
				if (subram_vrambank == 3) {
					/* oN3݂͑Ȃ */
					ASSERT(FALSE);
					LOG1(Warning, "mVRAMoNw(%d)", subram_vrambank);
					subram_vrambank = 0;
				}

				/* |C^č\ */
				display_setpointer(FALSE);
			}
			else {
				LOG2(Warning, "`oCg $%04X <- $%02X", addr, dat);
			}
			return TRUE;
#endif

#if XM7_VER >= 2
		/* FM77AV MISCWX^ */
		case 0xd430:
			/* FM77AVȍ~ŗL */
			if (model_type >= MODEL_FM77AV) {
				redraw_flag = FALSE;

				/* NMI}XN */
				if (dat & 0x80) {
					subnmi_flag = FALSE;
					event[EVENT_SUBTIMER].flag = EVENT_DISABLED;
					subcpu.intr &= ~INTR_NMI;
				}
				else {
					subnmi_flag = TRUE;
					event[EVENT_SUBTIMER].flag = EVENT_ENABLED;
				}

				/* ANeBuy[W */
				if (dat & 0x20) {
					vram_active = 1;
				}
				else {
					vram_active = 0;
				}

				/* fBXvCy[W */
				if (dat & 0x40) {
					if (vram_display == 0) {
						vram_display = 1;

						/* 200C8F[hł͉ʍĕ`悪Kv */
#if XM7_VER >= 3
						if (screen_mode == SCR_200LINE) {
#else
						if (!mode320) {
#endif
							redraw_flag = TRUE;
						}
					}
				}
				else {
					if (vram_display == 1) {
						vram_display = 0;

						/* 200C8F[hł͉ʍĕ`悪Kv */
#if XM7_VER >= 3
						if (screen_mode == SCR_200LINE) {
#else
						if (!mode320) {
#endif
							redraw_flag = TRUE;
						}
					}
				}

				/* gVRAMItZbgWX^ */
				if (dat & 0x04) {
					vram_offset_flag = TRUE;
				}
				else {
					vram_offset_flag = FALSE;
				}

				/* CGROMoN */
				cgrom_bank = (BYTE)(dat & 0x03);

				/* |C^č\Eʍĕ` */
				display_setpointer(redraw_flag);
			}
			else {
				LOG2(Warning, "`oCg $%04X <- $%02X", addr, dat);
			}

			return TRUE;
#endif

#if XM7_VER >= 3
		/* FM77AV40EX VRAMubNZNg */
		case 0xd433:
			/* FM77AV40EX̂ݗL */
			if (model_type == MODEL_FM77AV40EX) {
				redraw_flag = FALSE;

				/* bit0:ANeBuubNZNg */
				if (dat & 0x01) {
					block_active = 1;
				}
				else {
					block_active = 0;
				}

				/* bit4:\ubNZNg */
				if (dat & 0x10) {
					if (block_display == 0) {
						block_display = 1;
						if (screen_mode != SCR_262144) {
							redraw_flag = TRUE;
						}
					}
				}
				else {
					if (block_display == 1) {
						block_display = 0;
						if (screen_mode != SCR_262144) {
							redraw_flag = TRUE;
						}
					}
				}

				/* |C^č\Eʍĕ` */
				display_setpointer(redraw_flag);
			}
			else {
				LOG2(Warning, "`oCg $%04X <- $%02X", addr, dat);
			}
			return TRUE;

		/* FM77AV40EX n[hEFAEBhE */
		case 0xd438:			/* XEBhEX^[gAhX() */
		case 0xd439:			/* XEBhEX^[gAhX() */
		case 0xd43a:			/* XEBhEGhAhX() */
		case 0xd43b:			/* XEBhEGhAhX() */
		case 0xd43c:			/* YEBhEX^[gAhX() */
		case 0xd43d:			/* YEBhEX^[gAhX() */
		case 0xd43e:			/* YEBhEGhAhX() */
		case 0xd43f:			/* YEBhEGhAhX() */
			/* FM77AV40EX̂ݗL */
			if (model_type != MODEL_FM77AV40EX) {
				LOG2(Warning, "`oCg $%04X <- $%02X", addr, dat);
				return TRUE;
			}

			switch (addr & 7) {
				case 0:	/* XEBhEX^[gAhX() */
						window_x1 &= (WORD)0x00f8;
						window_x1 |= (WORD)((dat & 0x03) << 8);
						break;
				case 1:	/* XEBhEX^[gAhX() */
						window_x1 &= (WORD)0x0300;
						window_x1 |= (WORD)(dat & 0xf8);
						break;
				case 2:	/* XEBhEGhAhX() */
						window_x2 &= (WORD)0x00f8;
						window_x2 |= (WORD)((dat & 0x03) << 8);
						break;
				case 3:	/* XEBhEGhAhX() */
						window_x2 &= (WORD)0x0300;
						window_x2 |= (WORD)(dat & 0xf8);
						break;
				case 4:	/* YEBhEX^[gAhX() */
						window_y1 &= (WORD)0x00ff;
						window_y1 |= (WORD)((dat & 0x01) << 8);
						break;
				case 5:	/* YEBhEX^[gAhX() */
						window_y1 &= (WORD)0x0100;
						window_y1 |= (WORD)dat;
						break;
				case 6:	/* YEBhEGhAhX() */
						window_y2 &= (WORD)0x00ff;
						window_y2 |= (WORD)((dat & 0x01) << 8);
						break;
				case 7:	/* YEBhEGhAhX() */
						window_y2 &= (WORD)0x0100;
						window_y2 |= (WORD)dat;
						break;
				default:
						ASSERT(FALSE);
			}

			check_window_open();
			return TRUE;
#endif
	}

	return FALSE;
}

/*
 *	fBXvC
 *	Z[u
 */
BOOL FASTCALL display_save(int fileh)
{
	LOG0(Normal, "Z[u");

	if (!file_bool_write(fileh, crt_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, vrama_flag)) {
		return FALSE;
	}

#if XM7_VER >= 2
	if (!file_bool_write(fileh, subnmi_flag)) {
		return FALSE;
	}
#endif
	if (!file_bool_write(fileh, vsync_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, blank_flag)) {
		return FALSE;
	}

	if (!file_bool_write(fileh, vram_offset_flag)) {
		return FALSE;
	}
#if XM7_VER >= 2
	if (!file_word_write(fileh, vram_offset[0])) {
		return FALSE;
	}
	if (!file_word_write(fileh, vram_offset[1])) {
		return FALSE;
	}
	if (!file_word_write(fileh, crtc_offset[0])) {
		return FALSE;
	}
	if (!file_word_write(fileh, crtc_offset[1])) {
		return FALSE;
	}

	if (!file_byte_write(fileh, vram_active)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, vram_display)) {
		return FALSE;
	}
#else
	if (!file_word_write(fileh, vram_offset[0])) {
		return FALSE;
	}
	if (!file_word_write(fileh, crtc_offset[0])) {
		return FALSE;
	}
#endif

	/* Ver6g */
	if (!file_word_write(fileh, 0)) {
		return FALSE;
	}

#if XM7_VER >= 3
	/* Ver8g */
	if (!file_byte_write(fileh, subram_vrambank)) {
		return FALSE;
	}
	if (!file_word_write(fileh, kanji_addr)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, sub_kanji_bank)) {
		return FALSE;
	}

	if (!file_word_write(fileh, window_x1)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_dx1)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_y1)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_dy1)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_x2)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_dx2)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_y2)) {
		return FALSE;
	}
	if (!file_word_write(fileh, window_dy2)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, window_open)) {
		return FALSE;
	}

	if (!file_byte_write(fileh, block_active)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, block_display)) {
		return FALSE;
	}
#endif

#if XM7_VER == 1 && defined(L4CARD)
	/* XM7 V1.1 / FM-77L4eLXgVRAM܂ */
	if (!file_bool_write(fileh, width40_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, cursor_lsb)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, text_blink)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, cursor_blink)) {
		return FALSE;
	}
	if (!file_word_write(fileh, text_start_addr)) {
		return FALSE;
	}
	if (!file_word_write(fileh, cursor_addr)) {
		return FALSE;
	}

	if (!file_bool_write(fileh, enable_400line)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, workram_select)) {
		return FALSE;
	}
	if (!file_word_write(fileh, kanji_addr)) {
		return FALSE;
	}

	if (!file_byte_write(fileh, crtc_regnum)) {
		return FALSE;
	}
	if (!file_write(fileh, crtc_register, 0x20)) {
		return FALSE;
	}
#endif

	/* Ver9.18/Ver7.18/Ver3.08g */
	if (!file_dword_write(fileh, now_raster)) {
		return FALSE;
	}

	return TRUE;
}

/*
 *	fBXvC
 *	[h
 */
BOOL FASTCALL display_load(int fileh, int ver)
{
	WORD tmp;

	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	LOG0(Normal, "[h");

	if (!file_bool_read(fileh, &crt_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &vrama_flag)) {
		return FALSE;
	}

#if XM7_VER >= 2
	if (!file_bool_read(fileh, &subnmi_flag)) {
		return FALSE;
	}
#endif
	if (!file_bool_read(fileh, &vsync_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &blank_flag)) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &vram_offset_flag)) {
		return FALSE;
	}
#if XM7_VER >= 2
	if (!file_word_read(fileh, &vram_offset[0])) {
		return FALSE;
	}
	if (!file_word_read(fileh, &vram_offset[1])) {
		return FALSE;
	}
	if (!file_word_read(fileh, &crtc_offset[0])) {
		return FALSE;
	}
	if (!file_word_read(fileh, &crtc_offset[1])) {
		return FALSE;
	}

	if (!file_byte_read(fileh, &vram_active)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &vram_display)) {
		return FALSE;
	}
#else
	if (!file_word_read(fileh, &vram_offset[0])) {
		return FALSE;
	}
	if (!file_word_read(fileh, &crtc_offset[0])) {
		return FALSE;
	}
#endif

	/* Ver6g */
#if XM7_VER >= 2
	if (ver >= 600) {
#else
	if (ver >= 300) {
#endif
		if (!file_word_read(fileh, &tmp)) {
			return FALSE;
		}
	}

#if XM7_VER >= 3
	/* Ver8g */
	if (((ver >= 800) && (ver < 1000)) || (ver >= 1400)) {
		if (!file_byte_read(fileh, &subram_vrambank)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &tmp)) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &sub_kanji_bank)) {
			return FALSE;
		}

		if (!file_word_read(fileh, &window_x1)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_dx1)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_y1)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_dy1)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_x2)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_dx2)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_y2)) {
			return FALSE;
		}
		if (!file_word_read(fileh, &window_dy2)) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &window_open)) {
			return FALSE;
		}

		if (!file_byte_read(fileh, &block_active)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &block_display)) {
			return FALSE;
		}

		/* AV40/AV40EXȊO */
		if ((model_type < MODEL_FM77AV40)) {
			if (subram_vrambank || sub_kanji_bank) {
				return FALSE;
			}
		}
		/* AV40EXȊO */
		if (model_type != MODEL_FM77AV40EX) {
			if (window_x1 || window_dx1 || window_y1 || window_dy1 ||
				window_x2 || window_dx2 || window_y2 || window_dy2 ||
				window_open || block_active || block_display) {
				return FALSE;
			}
		}
	}
	else {
		subram_vrambank = 0;
		sub_kanji_bank = FALSE;

		window_x1 = 0;
		window_dx1 = 0;
		window_x2 = 0;
		window_dx2 = 0;
		window_y1 = 0;
		window_dy1 = 0;
		window_y2 = 0;
		window_dy2 = 0;
		window_open = FALSE;

		block_active = 0;
		block_display = 0;
	}
#endif

#if XM7_VER == 1 && defined(L4CARD)
	/* XM7 V1.1 / FM-77L4eLXgVRAM܂ */
	if (!file_bool_read(fileh, &width40_flag)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &cursor_lsb)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &text_blink)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &cursor_blink)) {
		return FALSE;
	}
	if (!file_word_read(fileh, &text_start_addr)) {
		return FALSE;
	}
	if (!file_word_read(fileh, &cursor_addr)) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &enable_400line)) {
		return FALSE;
	}
	/* 400CJ[h`FbN */
	if (enable_400line && !detect_400linecard) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &workram_select)) {
		return FALSE;
	}
	if (!file_word_read(fileh, &tmp)) {
		return FALSE;
	}

	if (!file_byte_read(fileh, &crtc_regnum)) {
		return FALSE;
	}
	if (!file_read(fileh, crtc_register, 0x20)) {
		return FALSE;
	}
#endif

	/* Ver9.18/Ver7.18/Ver3.08g */
#if XM7_VER >= 3
	if ((ver >= 918) || ((ver >= 718) && (ver <= 799))) {
#elif XM7_VER >= 2
	if (ver >= 718) {
#else
	if (((ver >= 308) && (ver <= 399)) || (ver >= 410)) {
#endif
		if (!file_dword_read(fileh, (DWORD *)&now_raster)) {
			return FALSE;
		}
	}
	else {
		now_raster = 0;
	}

	/* Ver3.10g */
#if XM7_VER == 1 && defined(L4CARD)
	if ((ver >= 310) && (ver <= 399)) {
		if (!file_byte_read(fileh, (BYTE *)&tmp)) {
			return FALSE;
		}
	}
#endif

	/* Cxg */
	schedule_handle(EVENT_SUBTIMER, subcpu_event);
	schedule_handle(EVENT_VSYNC, display_vsync);
	schedule_handle(EVENT_BLANK, display_hblank);
#if XM7_VER == 1 && defined(L4CARD)
	schedule_handle(EVENT_TEXT_BLINK, display_text_blink);
#endif

	/* |C^\ */
	display_setpointer(TRUE);
	display_vblank();

	return TRUE;
}
