/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ fBXvC ]
 */

#ifndef _display_h_
#define _display_h_

/*
 *	ʃ[h`
 */
#define	SCR_200LINE	0x00
#define	SCR_4096	0x01
#define	SCR_400LINE	0x02
#define	SCR_262144	0x03
#define	SCR_ANALOG	0x01
#define	SCR_AV40	0x02

#if XM7_VER >= 3
#define	SCR_MODE_ANALOG	(screen_mode & SCR_ANALOG)
#define	SCR_MODE_400LIN	(mode400l)
#elif XM7_VER >= 2
#define	SCR_MODE_ANALOG	(mode320)
#define	SCR_MODE_400LIN	(0)
#else
#define	SCR_MODE_ANALOG	(0)
#define	SCR_MODE_400LIN	(0)
#endif

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL display_init(void);
										/*  */
void FASTCALL display_cleanup(void);
										/* N[Abv */
void FASTCALL display_reset(void);
										/* Zbg */
BOOL FASTCALL display_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL display_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL display_save(int fileh);
										/* Z[u */
BOOL FASTCALL display_load(int fileh, int ver);
										/* [h */

void FASTCALL display_setpointer(BOOL redraw);
										/* ֘A[N̍Đݒ */
#if XM7_VER >= 3
void FASTCALL window_clip(int mode);
										/* EChENbsO */
BOOL FASTCALL fix_vram_address(void);
										/* 400C[hpVRAMzu␳ */
#endif

/*
 *	v[N
 */
extern BOOL crt_flag;
										/* CRT\tO */
extern BOOL vrama_flag;
										/* VRAMANZXtO */
extern WORD vram_offset[2];
										/* VRAMItZbgWX^ */
extern BOOL vram_offset_flag;
										/* gVRAMItZbgtO */
extern BOOL vsync_flag;
										/* VSYNCtO */
extern BOOL blank_flag;
										/* uLOtO */
extern BOOL draw_aftervsync;
										/* ʕ`ʒm^C~O */
extern int now_raster;
										/* ݃X^ʒu */
extern BOOL magus_patch;
										/* MAGUSpb` */

#if XM7_VER >= 2
extern BOOL subnmi_flag;
										/* TuNMICl[utO */
extern BYTE vram_active;
										/* ANeBuy[W */
extern BYTE *vram_aptr;
										/* VRAMANeBu|C^ */
extern BYTE vram_display;
										/* \y[W */
extern BYTE *vram_dptr;
										/* VRAM\|C^ */

#if XM7_VER >= 3
/* FM77AV40 */
extern BYTE screen_mode;
										/* ʃ[h */
extern BYTE subram_vrambank;
										/* ANeBuy[W(400line/26F) */
extern BOOL sub_kanji_bank;
										/* ROMI */

/* FM77AV40EX */
extern WORD window_x1, window_dx1;
										/* n[hEFAEBhE X1 */
extern WORD window_y1, window_dy1;
										/* n[hEFAEBhE Y1 */
extern WORD window_x2, window_dx2;
										/* n[hEFAEBhE X2 */
extern WORD window_y2, window_dy2;
										/* n[hEFAEBhE Y2 */
extern BOOL window_open;
										/* EBhEI[vtO */
extern BYTE block_active;
										/* ANeBuubN */
extern BYTE block_display;
										/* \ubN */
extern BYTE *vram_ablk;
										/* ANeBuubN|C^ */
extern BYTE *vram_bdptr;
										/* \ubN|C^ */
extern BYTE *vram_dblk;
										/* \ubN|C^ */
extern BYTE *vram_bdblk;
										/* \ubN|C^2 */
#endif
#endif

#if XM7_VER == 1 && defined(L4CARD)
extern BOOL width40_flag;
										/* WIDTH40[htO */
extern BOOL cursor_lsb;
										/* J[\AhXLSB */
extern BOOL enable_400line;
										/* 400C[htO */
extern BOOL workram_select;
										/* [NRAMItO */
extern BYTE crtc_register[0x20];
										/* CRTCWX^ */
extern BYTE crtc_regnum;
										/* CRTCWX^ԍWX^ */
extern WORD text_start_addr;
										/* eLXgX^[gAhX */
extern BOOL text_blink;
										/* eLXguN */
extern WORD cursor_addr;
										/* J[\AhX */
extern BOOL cursor_blink;
										/* J[\uN */
#endif
#if XM7_VER >= 3
extern const BYTE truecolorbrightness[64];
										/* 24/32bit ColorpPxe[u */
#endif

#ifdef __cplusplus
}
#endif

#endif	/* _display_h_ */
