/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ L[{[h ]
 */

#ifndef _keyboard_h_
#define _keyboard_h_

/*
 *	萔`
 */
#define KEY_FORMAT_9BIT		0			/* FM-7݊ */
#define KEY_FORMAT_FM16B	1			/* FM-16݊ */
#define KEY_FORMAT_SCAN		2			/* R[h[h */

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL keyboard_init(void);
										/*  */
void FASTCALL keyboard_cleanup(void);
										/* N[Abv */
void FASTCALL keyboard_reset(void);
										/* Zbg */
BOOL FASTCALL keyboard_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL keyboard_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL keyboard_save(int fileh);
										/* Z[u */
BOOL FASTCALL keyboard_load(int fileh, int ver);
										/* [h */
void FASTCALL keyboard_repeat(void);
										/* L[s[g^C}ύX */
void FASTCALL keyboard_make(BYTE dat);
										/* L[ */
void FASTCALL keyboard_break(BYTE dat);
										/* L[ */
void FASTCALL keyboard_inputmask(BOOL);
										/* L[͋֎~/ */
#ifdef KBDPASTE
BOOL FASTCALL keyboard_paste(BYTE dat);
										/* L[y[Xg */
#endif

/*
 *	v[N
 */
extern BOOL caps_flag;
										/* CAPS tO */
extern BOOL kana_flag;
										/* Ji tO */
extern BOOL ins_flag;
										/* INS tO */
extern BOOL shift_flag;
										/* SHIFTL[tO */
extern BOOL lshift_flag;
										/* SHIFTL[tO */
extern BOOL rshift_flag;
										/* ESHIFTL[tO */
extern BOOL ctrl_flag;
										/* CTRLL[tO */
extern BOOL graph_flag;
										/* GRAPHL[tO */
extern BOOL break_flag;
										/* BreakL[tO */
extern BYTE key_scan;
										/* L[R[h(, Make/Breakp) */
extern WORD key_fm7;
										/* L[R[h(FM-7݊) */
extern BOOL key_repeat_flag;
										/* L[s[gLtO */

extern BYTE key_format;
										/* R[htH[}bg */
extern DWORD key_repeat_time1;
										/* L[s[gJn */
extern DWORD key_repeat_time2;
										/* L[s[gԊu */

extern BYTE simpose_mode;
										/* X[p[C|[Y [h */
extern BOOL simpose_half;
										/* X[p[C|[Y n[tg[ */
extern BOOL digitize_enable;
										/* fBW^CYLEtO */
extern BOOL digitize_keywait;
										/* fBW^CYL[҂ */
#if XM7_VER >= 2
extern BOOL keyenc_beep_flag;
										/* L[GR[_PBEEPtO */
#else
extern BOOL key_mode_flag;
										/* FM-8[hFM-7݊L[̓[htO */
extern BYTE key_push_data[16];
										/* L[͏ */
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _keyboard_h_ */
