/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ MMR,TWR / I/O^RAMfBXN ]
 */

#ifndef _mmr_h_
#define _mmr_h_

/*
 *	^`
 */
enum {
	EXRAM_OFF = 0,						/* gRAM OFF[h() */
	EXRAM_64KB,							/* gRAM 64KB[h+oNZNg(FM-77) */
	EXRAM_192KB,						/* gRAM 192KB[h(FM-77) */
	EXRAM_960KB,						/* gRAM 960KB[h+gMMR/MSR */
	EXRAM_256KB,						/* gRAM 256KB[h(FM77AV40) */
	EXRAM_768KB,						/* gRAM 768KB[h(FM77AV40) */
};

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL mmr_init(void);
										/*  */
void FASTCALL mmr_cleanup(void);
										/* N[Abv */
void FASTCALL mmr_reset(void);
										/* Zbg */
BOOL FASTCALL mmr_trans_twr(WORD addr, DWORD *taddr);
										/* TWRAhXϊ */
DWORD FASTCALL mmr_trans_mmr(WORD addr);
										/* MMRAhXϊ */
BOOL FASTCALL mmr_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL mmr_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL mmr_extrb(WORD *addr, BYTE *dat);
										/* MMRoRǂݏo */
BOOL FASTCALL mmr_extbnio(WORD *addr, BYTE *dat);
										/* MMRoRǂݏo(I/OȂ) */
BOOL FASTCALL mmr_extwb(WORD *addr, BYTE dat);
										/* MMRoR */
BOOL FASTCALL mmr_extrbsegnio(WORD *addr, BYTE *dat, BYTE seg, int mode);
										/* MMRoRǂݏo(MSRw,I/OȂ) */
BOOL FASTCALL mmr_extwbseg(WORD *addr, BYTE dat, BYTE seg, int mode);
										/* MMRoR(MSRw) */
BOOL FASTCALL mmr_save(int fileh);
										/* Z[u */
BOOL FASTCALL mmr_load(int fileh, int ver);
										/* [h */

/*
 *	v[N
 */
extern BOOL mmr_flag;
										/* MMRLtO */
extern BYTE mmr_seg;
										/* MMRZOg */
extern BOOL mmr_modify;
										/* MMRԕύXtO */
#if XM7_VER >= 3
extern BYTE mmr_reg[0x80];
										/* MMRWX^ */
extern BOOL mmr_ext;
										/* gMMRLtO */
extern BOOL mmr_fastmode;
										/* MMRtO */
extern BYTE mmr_extram;
										/* gRAM[h */
extern BOOL mmr_fast_refresh;
										/* tbVtO */
extern BOOL twr_fastmode;
										/* TWR[h */
extern BOOL dsp_400linetiming;
										/* 400C^C~Oo̓tO */
#else
#if XM7_VER >= 2
extern BYTE mmr_reg[0x80];
										/* MMRWX^ */
extern BOOL mmr_ext;
										/* gMMRLtO */
extern BOOL mmr_fastmode;
										/* MMRtO */
extern BOOL mmr_fast_refresh;
										/* tbVtO */
#elif XM7_VER == 1
extern BYTE mmr_reg[0x400];
										/* MMRWX^ */
extern BYTE mmr_extram;
										/* gRAM[h */
#else
extern BYTE mmr_reg[0x40];
										/* MMRWX^ */
#endif
#endif

extern BOOL twr_flag;
										/* TWRLtO */
extern BYTE twr_reg;
										/* TWRWX^ */
extern BYTE wbr_reg;
										/* WBRWX^ */
extern BYTE bsr_reg;
										/* gRAMoNZNgWX^ */
#ifdef __cplusplus
}
#endif

#endif	/* _mmr_h_ */
