/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ CeWFg}EX/}EXZbg ]
 */

#ifdef MOUSE

#include <assert.h>
#include <string.h>
#include "xm7.h"
#include "device.h"
#include "mainetc.h"
#include "event.h"
#include "mouse.h"

/*
 *	O[o [N
 */
BYTE mos_port;							/* }EXڑ|[g */
BOOL mos_enable;						/* }EXLtO */

/*
 *	X^eBbN [N
 */
static BYTE mos_x;						/* wړ (:+ E:-) */
static BYTE mos_y;						/* xړ (:+ :-) */
static BYTE mos_phase;					/* tF[YJE^ */
static BOOL mos_strobe;					/* Xg[uM(ۑp) */
static BYTE mosset_x;					/* MS Xړ (:- E:+) */
static BYTE mosset_y;					/* MS Yړ (:- :+) */
static BYTE mosset_phase;				/* MS tF[YJE^ */

/*
 *	ID
 */
#define	ID	MAKEID('M', 'O', 'U', 'S')
//#define MOUSE_LOG

/*
 *	CeWFg}EX
 *	
 */
BOOL FASTCALL mos_init(void)
{
	/* }EXڑ𖳌ɂ */
	mos_port = 1;
	mos_enable = FALSE;

	return TRUE;
}

/*
 *	CeWFg}EX
 *	N[Abv
 */
void FASTCALL mos_cleanup(void)
{
}

/*
 *	CeWFg}EX
 *	Zbg
 */
void FASTCALL mos_reset(void)
{
	LOG0(Normal, "Zbg");

	/* [NGA */
	mos_x = 0;
	mos_y = 0;
	mos_phase = 0;
	mos_strobe = FALSE;
	mosset_x = 0;
	mosset_y = 0;
	mosset_phase = 0;
}

/*
 *	}EXZbg
 *	PoCgǂݍ
 */
BOOL FASTCALL mouse_readb(WORD addr, BYTE *dat)
{
#if XM7_VER == 1
	if (model_type == MODEL_FM8) {
		return FALSE;
	}
#endif

	if (mos_port != 3) {
		return FALSE;
	}

	switch (addr) {
		/* STATUS REGISTER */
		case 0xfde8 :
			if (!mos_enable) {
				*dat = 0x80;
				return TRUE;
			}

			/* tF[YJE^ɏ]ăf[^쐬 */
			mosset_phase ++;
			switch (mosset_phase) {
				case 1 :	/* wʃju */
							*dat = (BYTE)(mosset_x & 0x0f);
							break;
				case 2 :	/* wʃju */
							*dat = (BYTE)((mosset_x >> 4) & 0x0f);
							break;
				case 3 :	/* xʃju */
							*dat = (BYTE)(mosset_y & 0x0f);
							break;
				case 4 :	/* xʃju */
							*dat = (BYTE)((mosset_y >> 4) & 0x0f);
							mosset_phase = 0;
							break;
			}

			/* {^ԃf[^ */
			*dat |= (BYTE)((~mosbtn_request() & 0x30) | 0x80);

			return TRUE;
	}

	return FALSE;
}

/*
 *	}EXZbg
 *	PoCg
 */
BOOL FASTCALL mouse_writeb(WORD addr, BYTE dat)
{
#if XM7_VER == 1
	if (model_type == MODEL_FM8) {
		return FALSE;
	}
#endif

	if (mos_port != 3) {
		return FALSE;
	}

	switch (addr) {
		/* CONTROL REGISTER */
		case 0xfde8:
			/* bit0̋@\悭킩ȂŃijQɎ蔲 */
			if (dat & 0x03) {
				/* tF[YJE^Zbg */
				mosset_phase = 0;

				if (mos_enable) {
					/* ړ擾 */
					mospos_request(&mosset_x, &mosset_y);

					/* ] */
					mosset_x = (BYTE)-mosset_x;
					mosset_y = (BYTE)-mosset_y;
				}
			}
			return TRUE;
	}

	return FALSE;
}

/*
 *	CeWFg}EX
 *	^CAEg
 */
static BOOL FASTCALL mos_timeout(void)
{
	/* ^CAEgCxg폜 */
	schedule_delevent(EVENT_MOUSE);

	/* Xg[uMEtF[YJE^Zbg */
	mos_phase = 0;
	mos_strobe = FALSE;

	return TRUE;
}

/*
 *	CeWFg}EX
 *	Xg[uM
 */
void FASTCALL mos_strobe_signal(BOOL strb)
{
	/* Xg[uM̏Ԃω`FbN */
	if (strb != mos_strobe) {
		/* Xg[uM̏Ԃۑ */
		mos_strobe = strb;

		if (mos_phase == 0) {
			/* tF[Y0̎Ɉړ荞 */
			mospos_request(&mos_x, &mos_y);

			/* ^CAEgCxg̓o^ */
			schedule_setevent(EVENT_MOUSE, 2000 , mos_timeout);
		}

		/* tF[YJE^XV */
		mos_phase = (BYTE)((mos_phase + 1) & 0x03);
	}
}

/*
 *	CeWFg}EX
 *	f[^ǂݍ
 */
BYTE FASTCALL mos_readdata(BYTE trigger)
{
	BYTE ret;

	/* tF[YJE^ɏ]ăf[^쐬 */
	switch (mos_phase) {
		case 1 :	/* wʃju */
					ret = (BYTE)((mos_x >> 4) & 0x0f);
					break;
		case 2 :	/* wʃju */
					ret = (BYTE)(mos_x & 0x0f);
					break;
		case 3 :	/* xʃju */
					ret = (BYTE)((mos_y >> 4) & 0x0f);
					break;
		case 0 :	/* xʃju */
					ret = (BYTE)(mos_y & 0x0f);
					break;
	}

	/* {^ԃf[^ */
	ret |= (BYTE)((mosbtn_request() & (trigger << 4)) & 0x30);

	return ret;
}

/*
 *	CeWFg}EX/}EXZbg
 *	Z[u
 */
BOOL FASTCALL mos_save(int fileh)
{
	LOG0(Normal, "Z[u");

	if (!file_byte_write(fileh, mos_x)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, mos_y)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, mos_phase)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, mos_strobe)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, mosset_x)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, mosset_y)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, mosset_phase)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, mos_port)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, mos_enable)) {
		return FALSE;
	}

	return TRUE;
}

/*
 *	CeWFg}EX/}EXZbg
 *	[h
 */
BOOL FASTCALL mos_load(int fileh, int ver)
{
	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	/* 񃊃Zbg */
	mos_reset();

	LOG0(Normal, "[h");

#if XM7_VER >= 3
	if ((ver >= 900) || ((ver >= 700) && (ver <= 799))) {
#elif XM7_VER >= 2
	if (ver >= 700) {
#else
	if (ver >= 302) {	/* V1.1L21̓o[Wɍ킹 */
#endif
		if (!file_byte_read(fileh, &mos_x)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &mos_y)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &mos_phase)) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &mos_strobe)) {
			return FALSE;
		}
	}

	/* Ver3.09/7.19/9.19ǉ */
#if XM7_VER == 1
	if (((ver >= 309) && (ver <= 399)) || (ver >= 1001)) {
#elif XM7_VER == 2
	if (ver >= 719) {
#else
	if (((ver >= 719) && (ver <= 799)) || (ver >= 919)) {
#endif
		if (!file_byte_read(fileh, &mosset_x)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &mosset_y)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &mosset_phase)) {
			return FALSE;
		}
	}

	/* Ver10.04/12.04/14.04ǉ */
#if XM7_VER == 1
	if (ver >= 1004) {
#elif XM7_VER == 2
	if (ver >= 1204) {
#else
	if (((ver >= 1204) && (ver <= 1399)) || (ver >= 1404)) {
#endif
		if (!file_byte_read(fileh, &mos_port)) {
			return FALSE;
		}
	}

	/* Ver14.11/Ver12.11/Ver10.12g */
#if XM7_VER >= 3
	if ((ver >= 1411) || ((ver >= 1211) && (ver <= 1399))) {
#elif XM7_VER >= 2
	if (ver >= 1211) {
#else
	if (ver >= 1012) {
#endif
		if (!file_bool_read(fileh, &mos_enable)) {
			return FALSE;
		}
	}

	/* Cxg */
	schedule_handle(EVENT_MOUSE, mos_timeout);

	return TRUE;
}

#endif	/* MOUSE */
