/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ vO}u^C}(MB8873H) ȈՔ ]
 */

#ifdef MOUSE

#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "xm7.h"
#include "device.h"
#include "mainetc.h"
#include "ptm.h"
#include "mouse.h"
#include "event.h"

/*
 *	O[o [N
 */
int ptm_counter[6];						/* JE^ */
int ptm_counter_preset[6];				/* JE^vZbgl */

BYTE ptm_mode_select[3];				/* 샂[h */
BOOL ptm_running_flag[3];				/* 쒆tO */

BOOL ptm_out_flag[3];					/* o͋tO */
BOOL ptm_irq_flag_int[3];				/* 荞݃tO */
BOOL ptm_irq_mask_int[3];					/* 荞݃}XNtO */
BOOL ptm_mode_16bit[3];					/* 16rbgJEg[h */
BOOL ptm_clock_type[3];					/* NbN */

BOOL ptm_preset_mode;					/* vZbg(InternalReset)[h */
BOOL ptm_select_reg1;					/* WX^I */
BOOL ptm_clock_divide;					/* NbN[h */

/*
 *	X^eBbN [N
 */
static BOOL ptm_counter_select[3];		/* fA[hWX^I */
static BYTE ptm_timer_adjust;			/* ^C}ԊuߎpJE^ */
static BYTE ptm_read_latch_buffer;		/* [hpb`obt@ */
static BYTE ptm_write_latch_buffer;		/* Cgpb`obt@ */

/*
 *	vg^Cv錾
 */
static BOOL FASTCALL ptm_event(void);

/*
 *	ID
 */
#define	ID	MAKEID('P', 'T', 'M', ' ')
//#define PTM_LOG

/*
 *	vO}u^C}
 *	
 */
BOOL FASTCALL ptm_init(void)
{
	return TRUE;
}

/*
 *	vO}u^C}
 *	N[Abv
 */
void FASTCALL ptm_cleanup(void)
{
}

/*
 *	vO}u^C}
 *	JE^Zbg
 */
static void FASTCALL ptm_counter_reset(void)
{
	int i;

	for (i=0; i<6; i++) {
		ptm_counter[i] = 0;
		ptm_counter_preset[i] = 0;
	}

	for (i=0; i<3; i++) {
		ptm_mode_select[i] = 0;
		ptm_running_flag[i] = FALSE;
		ptm_counter_select[i] = FALSE;
		ptm_clock_type[i] = FALSE;
	}

	ptm_preset_mode = TRUE;
}

/*
 *	vO}u^C}
 *	Zbg
 */
void FASTCALL ptm_reset(void)
{
	int i;

	LOG0(Normal, "Zbg");

	ptm_counter_reset();

	for (i=0; i<3; i++) {
		ptm_out_flag[i] = FALSE;
		ptm_irq_flag_int[i] = FALSE;
		ptm_irq_mask_int[i] = TRUE;
		ptm_mode_16bit[i] = TRUE;
	}

	ptm_read_latch_buffer = 0x00;
	ptm_write_latch_buffer = 0x00;

	ptm_clock_divide = FALSE;
	ptm_select_reg1 = FALSE;

	/* Cxg */
#if XM7_VER >= 2
	if (mos_port == 3) {
#else
	if ((mos_port == 3) && (model_type != MODEL_FM8)) {
#endif
		schedule_setevent(EVENT_PTM_TIMER, 52, ptm_event);
	}
	else {
		schedule_delevent(EVENT_PTM_TIMER);
	}
	ptm_timer_adjust = 0;
}

/*
 *	vO}u^C}
 *	Cxg
 */
static BOOL FASTCALL ptm_event(void)
{
	BYTE i;

	/* vZbg[hȂ牽Ȃ */
	if (ptm_preset_mode) {
		return TRUE;
	}

	/* 19.2kHz^C}ߎ */
	ptm_timer_adjust = (BYTE)((ptm_timer_adjust + 1) % 12);
	if (ptm_timer_adjust == 0) {
		schedule_setevent(EVENT_PTM_TIMER, 53, ptm_event);
	}
	else {
		schedule_setevent(EVENT_PTM_TIMER, 52, ptm_event);
	}

	/* e^C}𓮂 */
	for (i=0; i<3; i++) {
		if (ptm_running_flag[i]) {

			if (ptm_clock_type[i]) {
				ptm_counter[i] -= 104;
			}
			else {
				ptm_counter[i] --;
			}

			/* ȉAJE^OȉɂȂ甭 */
			if (ptm_counter[i] <= 0) {
				/* tO𗧂Ă */
				ptm_irq_flag_int[i] = TRUE;

				/* }XNĂȂΊ荞݂(CH0ȊO) */
				if (!(ptm_irq_mask_int[i] || ptm_irq_mask)) {
					ptm_irq_flag = TRUE;
					maincpu_irq();
				}

				if (ptm_mode_select[i] & 0x20) {
					/* VO[h̏ꍇ̓^C} */
					ptm_running_flag[i] = FALSE;
				}
				else {
					/* JE^Zbg */
					if ((ptm_mode_16bit[i]) || (!ptm_counter_select[i])) {
						ptm_counter[i] += ptm_counter_preset[i];
					}
					else {
						ptm_counter[i] += ptm_counter_preset[i + 3];
					}
					ptm_counter_select[i] = !ptm_counter_select[i];
				}
			}
		}
	}

	return TRUE;
}

/*
 *	JE^vZbg
 */
static void FASTCALL ptm_preset_counter(BYTE reg)
{
	/* \JE^ݒ */
	ptm_counter_preset[reg] = ptm_counter[reg];
	if (ptm_clock_divide) {
		ptm_counter_preset[reg] *= 8;
	}

	/* Wrbg[h̗JE^ݒ */
	if (!ptm_mode_16bit[reg]) {
		ptm_counter_preset[reg + 3] = ptm_counter[reg + 3];
		if (ptm_clock_divide) {
			ptm_counter_preset[reg + 3] *= 8;
		}
	}

	/* tOރZbg */
	ptm_running_flag[reg] = TRUE;
	ptm_counter_select[reg] = FALSE;
	ptm_irq_flag_int[reg] = FALSE;
}

/*
 *	Rg[WX^ݒ
 */
static void FASTCALL ptm_control_set(BYTE reg, BYTE dat)
{
	/* bit7:o̓}XN */
	if (dat & 0x80) {
		ptm_out_flag[reg] = TRUE;
	}
	else {
		ptm_out_flag[reg] = FALSE;
	}

	/* bit6:荞݃}XN */
	if (dat & 0x40) {
		ptm_irq_mask_int[reg] = FALSE;
	}
	else {
		ptm_irq_mask_int[reg] = TRUE;
	}

	/* bit1:NbNI */
	if (dat & 0x02) {
		/* bit1=1 : ENbN(2MHz)(܂ƂɑΉĂ܂) */
		ptm_clock_type[reg] = TRUE;
	}
	else {
		/* bit1=0 : CNbN(19.2kHz) */
		ptm_clock_type[reg] = FALSE;
	}

	/* bit2:[hI */
	if (dat & 0x04) {
		/* bit2=1 : 8rbg[h */
		ptm_mode_16bit[reg] = FALSE;
	}
	else {
		/* bit2=0 : 16rbg[h */
		ptm_mode_16bit[reg] = TRUE;
	}

	/* bit5-3:[hZNg */
	ptm_mode_select[reg] = (BYTE)(dat & 0x38);
	switch(dat & 0x38) {
		case 0x10 :	/* ReBj[[h(START) */
		case 0x30 :	/* VO[h(START) */
					ptm_preset_counter(reg);
					break;

		case 0x00 :	/* ReBj[[h(LATCH) */
		case 0x20 :	/* VO[h(LATCH) */
					break;

		case 0x08 :	/* gr[h(SHORT) */
		case 0x28 :	/* gr[h(LONG) */
		case 0x18 :	/* pXr[h(SHORT) */
		case 0x38 :	/* pXr[h(LONG) */
					ptm_running_flag[reg] = FALSE;
					ptm_irq_flag_int[reg] = FALSE;
					break;
	}
}

/*
 *	vO}u^C}
 *	PoCg擾
 */
BOOL FASTCALL ptm_readb(WORD addr,BYTE *dat)
{
	BYTE tmp;
	BYTE reg;

#if XM7_VER == 1
	if (model_type == MODEL_FM8) {
		return FALSE;
	}
#endif

	if (mos_port != 3) {
		return FALSE;
	}

	switch (addr) {
		/* Xe[^XWX^ */
		case 0xfde1:
			tmp = 0x00;
			if (ptm_irq_flag_int[0]) {
				tmp |= 0x01;
				ptm_irq_flag_int[0] = FALSE;
			}
			if (ptm_irq_flag_int[1]) {
				tmp |= 0x02;
				ptm_irq_flag_int[1] = FALSE;
			}
			if (ptm_irq_flag_int[2]) {
				tmp |= 0x04;
				ptm_irq_flag_int[2] = FALSE;
			}
			if (ptm_irq_flag) {
				tmp |= 0x80;
			}
			*dat = tmp;

			/* IRQ */
			ptm_irq_flag = FALSE;
			maincpu_irq();
			return TRUE;

		/* JE^(ʃoCg) */
		case 0xfde2:
		case 0xfde4:
		case 0xfde6:
			reg = (BYTE)((addr - 0xfde2) >> 1);
			if (ptm_mode_16bit[reg]) {
				/* PUrbg[h */
				*dat = (BYTE)(ptm_counter[reg] >> 8);
				ptm_read_latch_buffer = (BYTE)(ptm_counter[reg] & 0xFF);
			}
			else {
				/* Wrbg[h */
				*dat = (BYTE)(ptm_counter[reg] & 0xFF);
				ptm_read_latch_buffer = (BYTE)(ptm_counter[reg + 3] & 0xFF);
			}
			return TRUE;

		/* JE^(ʃoCg,b`obt@) */
		case 0xfde3:
		case 0xfde5:
		case 0xfde7:
			*dat = ptm_read_latch_buffer;
			return TRUE;
	}

	return FALSE;
}

/*
 *	vO}u^C}
 *	PoCg
 */
BOOL FASTCALL ptm_writeb(WORD addr, BYTE dat)
{
	BYTE reg;

#if XM7_VER == 1
	if (model_type == MODEL_FM8) {
		return FALSE;
	}
#endif

	if (mos_port != 3) {
		return FALSE;
	}

	switch (addr) {
		/* Rg[WX^ 1/3 */
		case 0xfde0:
			if (ptm_select_reg1) {
				/* bit0:^C}vZbg */
				if (dat & 0x01) {
					ptm_counter_reset();
				}
				else {
					ptm_control_set(0, dat);
					ptm_preset_mode = FALSE;
				}
			}
			else {
				/* bit0:NbNrbg */
				if (dat & 0x01) {
					ptm_clock_divide = TRUE;
				}
				else {
					ptm_clock_divide = FALSE;
				}
				ptm_control_set(2, dat);
			}
			return TRUE;

		/* Rg[WX^ 2 */
		case 0xfde1:
			ptm_control_set(1, dat);
			/* bit0 : WX^Irbg */
			if (dat & 0x01) {
				ptm_select_reg1 = TRUE;
			}
			else {
				ptm_select_reg1 = FALSE;
			}
			return TRUE;

		/* JE^(ʃoCg,b`obt@) */
		case 0xfde2:
		case 0xfde4:
		case 0xfde6:
			ptm_write_latch_buffer = (BYTE)dat;
			return TRUE;

		/* JE^(ʃoCg) */
		case 0xfde3:
		case 0xfde5:
		case 0xfde7:
			reg = (BYTE)((addr - 0xfde2) >> 1);
			if (ptm_mode_16bit[reg]) {
				/* PUrbg[h */
				ptm_counter[reg] = (WORD)((ptm_write_latch_buffer << 8) | dat);
			}
			else {
				/* Wrbg[h */
				ptm_counter[reg + 0] = (WORD)ptm_write_latch_buffer;
				ptm_counter[reg + 3] = (WORD)dat;
			}

			/* LATCH[h̃JE^Zbg */
			if (!(ptm_mode_select[reg] & 0x10)) {
				ptm_preset_counter(reg);
			}
			return TRUE;
	}

	return FALSE;
}

/*
 *	vO}u^C}
 *	Z[u
 */
BOOL FASTCALL ptm_save(int fileh)
{
	int i;

	LOG0(Normal, "Z[u");

	for (i=0; i<6; i++) {
		if (!file_dword_write(fileh, ptm_counter[i])) {
			return FALSE;
		}
		if (!file_dword_write(fileh, ptm_counter_preset[i])) {
			return FALSE;
		}
	}

	for (i=0; i<3; i++) {
		if (!file_byte_write(fileh, ptm_mode_select[i])) {
			return FALSE;
		}
		if (!file_bool_write(fileh, ptm_running_flag[i])) {
			return FALSE;
		}

		if (!file_bool_write(fileh, ptm_out_flag[i])) {
			return FALSE;
		}
		if (!file_bool_write(fileh, ptm_irq_flag_int[i])) {
			return FALSE;
		}
		if (!file_bool_write(fileh, ptm_irq_mask_int[i])) {
			return FALSE;
		}
		if (!file_bool_write(fileh, ptm_mode_16bit[i])) {
			return FALSE;
		}
		if (!file_bool_write(fileh, ptm_clock_type[i])) {
			return FALSE;
		}
	}

	if (!file_bool_write(fileh, ptm_preset_mode)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, ptm_select_reg1)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, ptm_clock_divide)) {
		return FALSE;
	}

	return TRUE;
}

/*
 *	vO}u^C}
 *	[h
 */
BOOL FASTCALL ptm_load(int fileh, int ver)
{
	int	i;

	LOG0(Normal, "[h");

	/* o[W`FbN */
#if XM7_VER == 1
	if ((ver < 309) || ((ver >= 400) && (ver <= 499))) {
#elif XM7_VER == 2
	if ((ver >= 500) && (ver < 719)) {
#else
	if (((ver >= 500) && (ver < 719)) || ((ver >= 800) && (ver < 919))) {
#endif
		return TRUE;
	}

	for (i=0; i<6; i++) {
		if (!file_dword_read(fileh, (DWORD *)&ptm_counter[i])) {
			return FALSE;
		}
		if (!file_dword_read(fileh, (DWORD *)&ptm_counter_preset[i])) {
			return FALSE;
		}
	}

	for (i=0; i<3; i++) {
		if (!file_byte_read(fileh, &ptm_mode_select[i])) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &ptm_running_flag[i])) {
			return FALSE;
		}

		if (!file_bool_read(fileh, &ptm_out_flag[i])) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &ptm_irq_flag_int[i])) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &ptm_irq_mask_int[i])) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &ptm_mode_16bit[i])) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &ptm_clock_type[i])) {
			return FALSE;
		}
	}

	if (!file_bool_read(fileh, &ptm_preset_mode)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &ptm_select_reg1)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &ptm_clock_divide)) {
		return FALSE;
	}

	/* Cxg */
	schedule_handle(EVENT_PTM_TIMER, ptm_event);

	return TRUE;
}

#endif
