/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ RS-232CC^tF[X ]
 */

#ifndef _rs232c_h_
#define _rs232c_h_

/*
 *	萔`
 */

/* Xe[^XWX^ */
#define	RSS_DSR			0x80
#define	RSS_SYNDET		0x40
#define	RSS_FRAMEERR	0x20
#define	RSS_OVERRUN		0x10
#define	RSS_PARITYERR	0x08
#define	RSS_TXEMPTY		0x04
#define	RSS_RXRDY		0x02
#define	RSS_TXRDY		0x01

/* [hR}hWX^ */
#define	RSM_STOPBITM	0xc0
#define	RSM_STOPBIT1	0x40
#define	RSM_STOPBIT15	0x80
#define	RSM_STOPBIT2	0xc0
#define	RSM_PARITYM		0x30
#define	RSM_PARITYEVEN	0x20
#define	RSM_PARITYEN	0x10
#define	RSM_CHARLENM	0x0c
#define	RSM_CHARLEN5	0x00
#define	RSM_CHARLEN6	0x04
#define	RSM_CHARLEN7	0x08
#define	RSM_CHARLEN8	0x0c
#define	RSM_BAUDDIVM	0x03
#define	RSM_BAUDDIV1	0x01
#define	RSM_BAUDDIV16	0x02
#define	RSM_BAUDDIV64	0x03

/* R}hWX^ */
#define	RSC_EH			0x80
#define	RSC_IR			0x40
#define	RSC_RTS			0x20
#define	RSC_ER			0x10
#define	RSC_SBRK		0x08
#define	RSC_RXE			0x04
#define	RSC_DTR			0x02
#define	RSC_TXEN		0x01

/* FM77AV40/20 NbNE{[[gݒ背WX^ */
#define	RSCB_CLKM		0xe0
#define	RSCB_BAUDM		0x1c
#define	RSCB_CD			0x04

/* FM77AV40/20 gDTR䃌WX^ */
#define	RSEX_DTR		0x04
#define	RSEX_RSENABLE	0x01

#ifdef RSC

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL rs232c_init(void);
										/*  */
void FASTCALL rs232c_cleanup(void);
										/* N[Abv */
void FASTCALL rs232c_reset(void);
										/* Zbg */
void FASTCALL rs232c_txrdy(BOOL flag);
										/* TxRDY/TxEMPTYMω */
void FASTCALL rs232c_txempty_request(void);
										/* TxEMPTYCxgo^ */
void FASTCALL rs232c_rxrdy(BOOL flag);
										/* RxRDYMω */
void FASTCALL rs232c_rxrdy_request(void);
										/* RxRDYCxgo^ */
void FASTCALL rs232c_syndet(BOOL flag);
										/* SYNDETMω */
void FASTCALL rs232c_calc_timing(void);
										/* M^C~OvZ */
BOOL FASTCALL rs232c_readb(WORD addr, BYTE *dat);
										/* 1oCgǂݏo */
BOOL FASTCALL rs232c_writeb(WORD addr, BYTE dat);
										/* 1oCg */
BOOL FASTCALL rs232c_save(int fileh);
										/* Z[u */
BOOL FASTCALL rs232c_load(int fileh, int ver);
										/* [h */

/*
 *	v[N
 */
extern BOOL	rs_use;
										/* RS-232CgptO */
extern BOOL	rs_mask;
										/* RS-232C@\}XN */
extern BOOL	rs_enable;
										/* RS-232CL */
extern BOOL	rs_selectmc;
										/* [hR}hI */
extern BYTE	rs_modecmd;
										/* [hR}hWX^ */
extern BYTE	rs_command;
										/* R}hWX^ */
extern BYTE	rs_baudrate;
										/* {[[gݒ背WX^ */
extern BYTE	rs_baudrate_v2;
										/* {[[gݒ(V1/V2p) */
extern BOOL rs_dtrmask;
										/* DTRM}XNtO */
extern BOOL rs_cd;
										/* CDM */
extern BOOL rs_cts;
										/* CTSM */
#ifdef __cplusplus
}
#endif

#endif	/* XM7_VER >= 3 */
#endif	/* _rs232c_h_ */
