/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *	line printer support 2010-2025 by Ben.JP
 *
 *	[ JZbge[vv^ ]
 */

#ifndef _tapelp_h_
#define _tapelp_h_

/*
 *	萔A^`
 */
#define	TAPE_SAVEBUFSIZE	4096			/* e[v݃obt@TCY */
#define	TAPE_LOADBUFSIZE	4096			/* e[vǂݍ݃obt@TCY */
#define	LP_TEMPFILENAME		"xm7_lpr.$$$"	/* v^ e|t@C */
#define	LP_DISABLE			0				/* v^ G~[V */
#define	LP_ENABLE			1				/* v^ G~[VL */
#define	LP_LOG				2				/* v^ Ot@Co */
#define	LP_JASTSOUND		3				/* v^ WXgTEho */
#define LPJOY_DEMPA			0				/* v^ dgVJOY I/F */
#define LPJOY_ASCII			1				/* v^ ASCII JOY I/F */
#define LPJOY_OHFM			2				/* v^ h!FM JOY I/F */

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL tapelp_init(void);
										/*  */
void FASTCALL tapelp_cleanup(void);
										/* N[Abv */
void FASTCALL tapelp_reset(void);
										/* Zbg */
BOOL FASTCALL tapelp_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL tapelp_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL tapelp_save(int fileh);
										/* Z[u */
BOOL FASTCALL tapelp_load(int fileh, int ver);
										/* [h */
void FASTCALL lp_setfile(char *fname);
										/* v^t@Cݒ */
#ifdef LPRINT
void FASTCALL lp_init(void);
										/* v^o  */
void FASTCALL lp_print(void);
										/* v^ֈ */
#endif
void FASTCALL tape_setfile(char *fname);
										/* e[vt@Cݒ */
void FASTCALL tape_setrec(BOOL flag);
										/* e[v^tOݒ */
void FASTCALL tape_rew(void);
										/* e[v߂ */
void FASTCALL tape_rewtop(void);
										/* e[vŏ܂Ŋ߂ */
void FASTCALL tape_ff(void);
										/* e[v */

/*
 *	v[N
 */
extern BOOL tape_in;
										/* e[v ̓f[^ */
extern BOOL tape_out;
										/* e[v o̓f[^ */
extern BOOL tape_motor;
										/* e[v [^ */
extern BOOL tape_rec;
										/* e[v ^ */
extern BOOL tape_writep;
										/* e[v ^s */
extern WORD tape_count;
										/* e[v JE^ */
extern DWORD tape_subcnt;
										/* e[v TuJEg */
extern int tape_fileh;
										/* e[v t@Cnh */
extern DWORD tape_offset;
										/* e[v t@CItZbg */
extern char tape_fname[256+1];
										/* e[v t@Cl[ */
extern BOOL tape_monitor;
										/* e[v e[vj^tO */
extern BOOL tape_sound;
										/* e[v [o̓tO */
#if XM7_VER == 1
extern BOOL tape_lowspeed;
										/* e[v [^I1.2MHztO */
#endif

#ifdef LPRINT
extern BYTE lp_mode;
										/* v^ ݒ胂[h */
#endif
extern BYTE lp_data;
										/* v^ o̓f[^ */
extern BOOL lp_busy;
										/* v^ BUSYtO */
extern BOOL lp_error;
										/* v^ G[tO */
extern BOOL lp_pe;
										/* v^ PEtO */
extern BOOL lp_ackng;
										/* v^ ACKtO */
extern BOOL lp_online;
										/* v^ IC */
extern BOOL lp_strobe;
										/* v^ Xg[u */
extern BYTE lp_joysticktype;
										/* v^ WCXeBbN^Cv */
extern char lp_fname[256+1];
										/* v^ t@Cl[ */
extern int lp_fileh;
										/* v^ t@Cnh */

#ifdef __cplusplus
}
#endif

#endif	/* _tapelp_h_ */
