/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ Win32API ]
 */

#ifdef _WIN32

#ifndef _w32_h_
#define _w32_h_

#ifndef __STDLIB_H
#include <stdlib.h>
#endif

/*
 *	萔A^`
 */
#ifndef WM_THEMECHANGED
#define WM_THEMECHANGED		0x031A		/* WindowsXP e[}KpbZ[W */
#endif
#ifndef	WM_MOUSEWHEEL
#define	WM_MOUSEWHEEL		0x020a		/* VS2005p(_WIN32_WINDOWS̑) */
#endif
#define	DWMWCP_DEFAULT		0
#define	DWMWCP_DONOTROUND	1
#define	DWMWCP_ROUND		2
#define DWMWCP_ROUNDSMALL	3
#define DWMWA_WINDOW_CORNER_PREFERENCE	33
typedef HRESULT (WINAPI *DWMSETWINDOWATTRIBUTE)(HWND, DWORD, LPCVOID, DWORD);

enum {
	DISK_IMAGE_DIR,
	TAPE_IMAGE_DIR,
	STATE_FILE_DIR,
	BMP_FILE_DIR,
	WAV_FILE_DIR,
#if XM7_VER == 1 && defined(BUBBLE)
	BUBBLE_IMAGE_DIR,
#endif	/* XM7_VER == 1 && defined(BUBBLE) */
	LPT_LOG_FILE_DIR,
	INITIAL_DIRS,						/* fBNg */
};

enum {
	FILE_MENU,
#if XM7_VER == 1 && defined(SFDC)
	SFD_MENU,
#endif	/* XM7_VER == 1 && defined(SFDC) */
	MFD_MENU,
#if XM7_VER == 1 && defined(BUBBLE)
	CASETTE_MENU,
#else	/* XM7_VER == 1 && defined(BUBBLE) */
	TAPE_MENU,
#endif	/* XM7_VER == 1 && defined(BUBBLE) */
	VIEW_MENU,
	DEBUG_MENU,
	TOOL_MENU,
	WINDOW_MENU,
	HELP_MENU,
};

enum {
	MRU_STATE = 0,
	MRU_TAPE,
	MRU_MFD0,
	MRU_MFD1,
	MRU_MFD2,
	MRU_MFD3,
#if XM7_VER == 1 && defined(SFDC)
	MRU_SFD0,
	MRU_SFD1,
	MRU_SFD2,
	MRU_SFD3,
#endif	/* XM7_VER == 1 && defined(SFDC) */
#if XM7_VER == 1 && defined(BUBBLE)
	MRU_BBL0,
	MRU_BBL1,
	MRU_BBL128_0,
	MRU_BBL128_1,
#endif	/* XM7_VER == 1 && defined(BUBBLE) */
	MRU_TYPES							/* MRU */
};
#define	MRU_FILES			9
#define MRU_MEDIAS			16

enum {
	XDL_SND = 0,
	XDL_FLT,
	XDL_TYPES							/* ODLL */
};
#define	XDL_FILES	9

enum {
	DISPLAYSIZE_100 = 0,
	DISPLAYSIZE_150,
	DISPLAYSIZE_200,
	DISPLAYSIZE_050,
	DISPLAYSIZE_180,
	DISPLAYSIZE_120,
	DISPLAYSIZE_300,
	DISPLAYSIZE_400,
	DISPLAYSIZE_TYPES,					/* 𑜓x */
};

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL IsJapanese(BOOL bNative);
										/* {̔ */
void FASTCALL SetJapaneseMode(BOOL mode);
										/* {ꃂ[h̐ݒ */
int FASTCALL GetMsg(HINSTANCE hInstance, UINT uID, char *string, int size);
										/* bZ[W擾 */
HFONT FASTCALL CreateTextFont(void);
										/* eLXgtHg쐬 */
void FASTCALL LockVM(void);
										/* VMbN */
void FASTCALL UnlockVM(void);
										/* VMAbN */
void FASTCALL OnSize(HWND hWnd, WORD cx, WORD cy);
										/* TCYύX */
void FASTCALL OnCommand(HWND hWnd, WORD wID);
										/* WM_COMMAND */
void FASTCALL OnMenuPopup(HWND hWnd, HMENU hMenu, UINT uPos);
										/* WM_INITMENUPOPUP */
void FASTCALL OnDropFiles(HANDLE hDrop);
										/* WM_DROPFILES */
void FASTCALL OnCmdLine(LPSTR lpCmdLine);
										/* R}hC */
void FASTCALL OnAbout(HWND hWnd);
										/* o[W */
void FASTCALL OnRefresh(HWND hWnd);
										/* ŐV̏ɍXV(R) */
BOOL FASTCALL FileSelectSub(BOOL bOpen, UINT uFilterID, char *path, char *defext, BYTE IniDirNo);
										/* t@CIR_CAO */
void FASTCALL EnableMenuSub(HMENU hMenu, UINT uID, BOOL bEnable);
										/* j[Enable */
void FASTCALL EnableMenuPos(HMENU hMenu, UINT uPos, BOOL bEnable);
										/* j[Enable (ʒuw) */
void FASTCALL CheckMenuSub(HMENU hMenu, UINT uID, BOOL bCheck);
										/* j[Check */
void FASTCALL InitIMEDLL(void);
										/* IMEL/API DLL */
void FASTCALL CleanIMEDLL(void);
										/* IMEL/API DLLN[Abv */
BOOL FASTCALL EnableIME(HWND hWnd, BOOL flag);
										/* IMEL/؂芷 */
#ifdef MOUSE
void FASTCALL MouseModeChange(BOOL flag);
										/* }EXLv`؂ւ */
#endif
void FASTCALL OnContextualMenu(HWND hWnd, WORD wID, int x, int y);
										/* ReLXgj[ */

/*
 *	v[N
 */
extern char InitialDir[INITIAL_DIRS][_MAX_PATH];
										/* fBNg */
extern char StatePath[_MAX_PATH];
										/* Xe[gpX */
extern char QuickPath[_MAX_PATH];
										/* NCbNXe[gpX */
extern BOOL bResumeState;
										/* Xe[gW[ */
extern BOOL bBackupState;
										/* Xe[gobNAbv */
extern BOOL bStateSave;
										/* Xe[gۑ@\ */
extern HINSTANCE hAppInstance;
										/* AvP[V CX^X */
extern HINSTANCE hResInstance;
										/* \[X CX^X */
extern HWND hMainWnd;
										/* CEChE */
extern HWND hDrawWnd;
										/* `EChE */
extern HWND hSubWndParent;
										/* TuEChEe */
extern int nErrorCode;
										/* G[R[h */
extern BOOL bMenuLoop;
										/* j[[v */
extern BOOL bMenuExit;
										/* j[otO */
extern BOOL bCloseReq;
										/* IvtO */
extern LONG lCharWidth;
										/* LN^ */
extern LONG lCharHeight;
										/* LN^c */
extern BOOL bSync;
										/* sɓ */
extern BOOL bSyncDisasm[4];
										/* tAZuPCɓ */
extern BOOL bMinimize;
										/* ŏtO */
extern BOOL bActivate;
										/* ANeBx[gtO */
extern HICON hAppIcon;
										/* ACRnh */
extern int nAppIcon;
										/* ACRԍ(1`3) */
extern BOOL bNTflag;
										/* OS^Cv1(NT) */
extern BOOL bXPflag;
										/* OS^Cv2(XP) */
extern BOOL bVistaflag;
										/* OS^Cv3(Vista) */
extern BOOL bWin7flag;
										/* OS^Cv4(Windows 7) */
extern BOOL bWin8flag;
										/* OS^Cv4(Windows 8) */
extern BOOL bWin10flag;
										/* OS^Cv3(Vista/7) */
extern BOOL bMMXflag;
										/* MMXΉtO */
extern BOOL bCMOVflag;
										/* CMOVΉtO */
extern BOOL bHighPriority;
										/* nCvCIeBtO */
extern POINT WinPos;
										/* EBhEʒu */
extern BOOL bOFNCentering;
										/* t@C_CAÕZ^O */
extern BOOL bRomeo;
										/* ROMEOFtO */
extern BOOL bSCCI_available;
										/* SCCIFtO */
#if ((XM7_VER <= 2) && defined(FMTV151))
extern BOOL bFMTV151;
										/* `lR[G~[V */
#endif
extern HFONT hFont;
										/* TuEBhEptHgnh */
#if XM7_VER >= 3
extern BOOL bGravestone;
										/* !? */
#endif
#ifdef RES_DLL
extern HINSTANCE hInstRes;
										/* DLL̃nh */
extern BOOL bUseLanguageMode;
										/* ꃂ[h؂ւ */
extern BOOL bExistResourceDll;
										/* \[XDLL݃tO */
#endif
extern BOOL bFilterRedrawScreen;
										/* j[ۂɉʂĕ` */
extern HMENU hMediaMenu;
										/* fBAj[nh */
extern HMENU hHistoryMenu;
										/* qXgj[nh */
extern HMENU hAspectMenu;
										/* AXyNgݒ胁j[nh */
#ifdef KBDPASTE
extern HWND hKeyStrokeDialog;
										/* L[͎x_CAOnh */
extern BOOL bKeyStrokeModeless;
										/* L[͎x_CAO[hXtO */
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _w32_h_ */
#endif	/* _WIN32 */
