/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2025 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2025 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2025 GIMONS
 *	Copyright (C) 2010-2025 Toma
 *
 *	[ Win32API L[{[hEWCXeBbNE}EX ]
 */

#ifdef _WIN32

#ifndef _w32_kbd_h_
#define _w32_kbd_h_

/*
 *	萔A^`
 */
#define KNT_KANJI		0
#define KNT_KANA		1
#define KNT_CAPS		2
#define KNT_RSHIFT		3
#define KEYBUFFER_SIZE	64

#define MOSCAP_NONE		0
#define MOSCAP_WMESSAGE	1
#define MOSCAP_WHEELWM	2

#define VKNT_CAPITAL	0xf0
#define VKNT_KATAKANA	0xf1
#define VKNT_KANA		0xf2
#define VKNT_KANJI1		0xf3
#define VKNT_KANJI2		0xf4

#ifndef WAIT_KEY_POP
/*
 *	ENTER/ESC/SPACE҂}N
 */
#define WAIT_KEY_POP()		while (	(GetAsyncKeyState(VK_RETURN) & 0x8000) || \
									(GetAsyncKeyState(VK_ESCAPE) & 0x8000) || \
									(GetAsyncKeyState(VK_SPACE) & 0x8000))
#endif

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
void FASTCALL InitKbd(void);
										/*  */
void FASTCALL CleanKbd(void);
										/* N[Abv */
BOOL FASTCALL SelectKbd(HWND hWnd);
										/* ZNg */
void FASTCALL SetMenuExitTimer(void);
										/* j[o^C}ݒ */
void FASTCALL PollKbd(void);
										/* L[{[h|[O */
void FASTCALL PollJoy(void);
										/* WCXeBbN|[O */
void FASTCALL GetDefMapKbd(BYTE *pMap, int mode);
										/* ftHg}bv擾 */
void FASTCALL SetMapKbd(BYTE *pMap);
										/* }bvݒ */
BOOL FASTCALL GetKbd(BYTE *pBuf);
										/* |[OL[擾 */
#ifdef MOUSE
void FASTCALL PollMos(void);
										/* }EX|[O */
void FASTCALL SetMouseCapture(BOOL en);
										/* }EXLv`ݒ */
#endif
#ifdef KBDPASTE
void FASTCALL PasteClipboardKbd(HWND hWnd);
										/*	L[{[hy[Xg */
void FASTCALL PasteKbd(char *pstring);
										/*	L[{[hy[Xg */
#endif

/*
 *	v[N
 */
extern BYTE kbd_map[256];
										/* L[{[h }bv */
extern BYTE kbd_table[256];
										/* ΉFM-7R[h */
extern int nJoyType[2];
										/* WCXeBbN^Cv */
extern int nJoyRapid[2][2];
										/* A˃^Cv */
extern int nJoyCode[2][7];
										/* R[h */
extern BOOL bKbdReal;
										/* [A^CL[XL */
extern BOOL bTenCursor;
										/* eL[ϊ */
extern BOOL bArrow8Dir;
										/* eL[ϊ 8[h */
extern BOOL bNTkeyPushFlag[4];
										/* L[tO(NT) */
extern BOOL bNTkeyMakeFlag[128];
										/* L[MaketO(NT) */
extern BOOL bNTkbMode;
										/* NT΍tO */
extern BOOL bAutoDetectKeyMap;
										/* L[}bvݒtO */
#ifdef MOUSE
extern BYTE uMidBtnMode;
										/* {^Ԏ擾[h */
extern BOOL bDetectMouse;
										/* }EXmFtO */
extern BOOL bMouseCapture;
										/* }EXLv`tO */
#endif
#ifdef KBDPASTE
extern UINT uPasteWait;
										/* y[Xg҂(ms) */
extern UINT uPasteWaitCntl;
										/* y[Xg҂(Rg[R[h) */
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _w32_kbd_h_ */
#endif	/* _WIN32 */
